//--------------------------------------------------------------------------------------------
//***  RSSREADER INTERFACE ***
//--------------------------------------------------------------------------------------------
var RssreaderInterface = function(paramObj, moduleObj) {
	var self = this;
	self.uuid = moduleObj.getModuleType();
	self.name = "rssreader";
	self.className = "Rssreader";
	self.path = APP_MODULES_PATH + "/" + self.uuid;
	self.nameInfo = self.path + "/" + self.className +"Interface.js";
	self.fXslFile_items = window.external.getAppPath() + "/modules/nosibox/lib_rss/xsl/rssInterfaceDefault.xsl";
	
	self.titleDiv = paramObj.titleInterface;
	self.headerContentDiv = paramObj.headerInterface;
	self.url = moduleObj.getModNodeValue("/url");
	self.iconImageObj = paramObj.getIconObj();
	self.readerObj = paramObj.readerObj;
	self.displayAddForm = paramObj.displayAddForm;
	
	self.maxitem = 10;

	//********************************************************************************************
	//--- PUBLIC METHODS
	//********************************************************************************************
	
	//Methode qui retourne l'lment Interface rempli
	self.getDiv = function() {
		return self.div;
	}
	
	function applyXslTemplateEx(xmlDoc, xslProc, tab_params, tab_objects) {
		
		var tmp = document.createElement("div");
		var output = applyXslTemplate( xmlDoc, xslProc, tab_params, tab_objects);
		if (output != null) {
			tmp.innerHTML = output;
		} else {
			tmp.innerHTML = '<br><br><center><span class="' + self.className + 'Main" style="width:100%;height:100%">' + moduleObj.getText("Unable to read feed") + '</span></center><br><br><br>';
		}
		return tmp;
	}
	
	//********************************************************************************************
	//--- PRIVATE METHODS
	//********************************************************************************************
	self.buildInterface = function() {
		self.build();
		self.readerObj.engineRequest( {force:false, method:'get', asynchronous:'true', onSuccess:self.loadBodyDiv, onFailure:self.errorBuildHTML, onException:self.errorRSSBuildHTML, onSimilar:self.loadBodyDiv});
	}
	
	self.build = function() {
		moduleObj.includeJs("player.js");
		self.div.innerHTML = ""
				+ '	<table class="module">'
				+ '	  <tr>'
				+ '	    <td>'
        		+ '       <table class="moduleHeader">'
        		+ '         <tr>'
				+ '			  <td class="moduleHeader_left"></td>'
				+ '           <td class="moduleHeader_center">'
        		+ '             <table class="moduleHeaderBar">'
        		+ '               <tr><td>'
        		+ '                 <span name="header"></span>'
       			+ '               </td></tr>'
        		+ '             </table>'
				+ '            </td>'
				+ '			  <td class="moduleHeader_right"></td>'
        		+ '         </tr>'
        		+ '       </table>'
        		+ '       <table class="moduleBody">'
        		+ '         <tr>'
				+ '           <td class="moduleBody_left"></td>'
				+ '           <td class="moduleBody_center">'
        		+ '           	<span name="body"></span>'
				+ '           </td>'
				+ '           <td class="moduleBody_right"></td>'
        		+ '         </tr>'
				+ '         <tr class="moduleBottom">'
				+ '           <td class="moduleBottom_left"></td>'
				+ '           <td class="moduleBottom_center"></td>'
				+ '           <td class="moduleBottom_right"></td>'
				+ '         </tr>'
        		+ '       </table>'
        		+ '     </td>'
				+ '	  </tr>'
				+ '	</table>';
				
		var tmp = self.div.getElementsByTagName("span")[0].parentNode.replaceChild(self.interfaceHeaderDiv, self.div.getElementsByTagName("span")[0]);
		var tmp = self.div.getElementsByTagName("span")[0].parentNode.replaceChild(self.interfaceBodyDiv, self.div.getElementsByTagName("span")[0]);
		delete(tmp);
		
		self.buildHeaderDiv();
		self.buildBodyContentDiv();
	}
	
	 self.buildHeaderDiv = function() {
    if ( ! self.headerContentDiv.innerHTML == "" ) {
        paramObj.buildHeaderDiv();
        self.headerContentDiv = paramObj.headerInterface;
        var title = self.headerContentDiv.innerText;
    }
	 	//On retire le lien
		var as = self.headerContentDiv.getElementsByTagName("a");
		if ( as.length > 0 ) {
		    var title = as[0].innerHTML;
		} else {
		    var title = self.headerContentDiv.innerText;
		}
		var imgs = self.headerContentDiv.getElementsByTagName("img");
		
    self.interfaceHeaderDiv.innerHTML = ""
			+ '<div class="modHeaderIcon"><span></span></div>'
      + '<div class="modHeaderTitle">'+title+'</div>'
      + '<div class="modHeaderButtons"><img src="' + APP_IMG_PATH + '/mod/bt_close_default.gif" onmouseover="this.src=\'' + APP_IMG_PATH + '/mod/bt_close_focus.gif\'; this.style.cursor=\'pointer\';" onmouseout="this.src=\'' + APP_IMG_PATH + '/mod/bt_close_default.gif\'"></div>';
		self.interfaceHeaderDiv.getElementsByTagName("span")[0].appendChild(imgs[0]);
        self.interfaceHeaderDiv.getElementsByTagName("img")[1].attachEvent("onclick",self.close);
	}
	
	self.buildBodyContentDiv = function() {
		var contentDiv = document.createElement("div");
		contentDiv.innerHTML = '<TABLE border="0" bgcolor="#FFFFFF" cellpadding="0" cellspacing="0" align="center" width="100%" height="100%">'
										+	'		<TR>'
										+	'			<TD valign="top" bgcolor="#FFFFFF"  align="center">'
										+	'				<IMG SRC="' + APP_IMG_PATH + '/vide.gif" border="0" width="1" height="10" /><br />'
										+	'				<span class="' + self.className + 'InterfaceBodyLine"><br><br>' + moduleObj.getText("Loading") + '<br><br><br></span>'
										+	'			</TD>'
										+	'		</TR>'
										+	'	</TABLE>';
		self.interfaceBodyContentDiv.appendChild(contentDiv);
		contentDiv = null;
		
		self.interfaceBodyButtonDiv.style.margin = "0px",
		self.interfaceBodyButtonDiv.style.paddingTop = "8px",
		self.interfaceBodyButtonDiv.style.paddingBottom = "8px",
		self.interfaceBodyButtonDiv.style.textAlign = "center",
		self.interfaceBodyButtonDiv.style.verticalAlign = "middle",
		self.interfaceBodyButtonDiv.innerHTML = '<div class="mainFormButton"><span id="livestickersButtons"><input type="button" class="mainFormButton_input" value="' + _("Close") + '"></span>';
		
		var spans = self.interfaceBodyButtonDiv.getElementsByTagName("span");
		for ( var i=0; nb = spans.length > i;i++) {
			if ( spans[i].id == "livestickersButtons" ) {
				spans[i].firstChild.onclick = function() {self.close()};
			}
		}
	}

	self.loadBodyDiv = function(response) {
		self.completeResponseXml = response.responseXml.cloneNode(true);
		self.completeResponseXml.preserveWhiteSpace = true;
		
		//Formulaire d'ajout du flux des les favoris 
		self.loadBodyFormAddDiv();
		
		//xsl pour rcuprer les categories et les trier 
		self.loadBodyFilterDiv();
		self.loadBodyContentDiv(response.responseXml);
	}
	

	
	self.loadBodyContentDiv = function(responseXML) {
		
		if ( ! self.numpage) {
			self.numpage = 1;
		}
		self.interfaceBodyContentDiv.innerHTML = "";

		self.interfaceBodyContentDiv.appendChild(applyXslTemplateEx(responseXML, self.fXslFile_items, [
																								["rssUrl", self.url]
																								,	["root",window.external.getAppPath() + "/"]
																								, ["numpage", self.numpage]
																								, ["maxitem", self.maxitem]
																								, ["paginationText1", moduleObj.getText("This feed contains")]
																								, ["paginationText2", moduleObj.getText("articles")]
																								, ["paginationText3", moduleObj.getText("Page")]
																								]));
//LCM HTA																					
		var link = moduleObj.getModNodeValue("/link");
		var url = "";
		var excludePath = "";
		if (link) {
			tab = link.split("/");
			if (tab && tab.length>3) url  = tab[0]+"/"+tab[1]+"/"+tab[2];
			excludePath = escape(window.external.getAppPath().replace("C:",""));
		}

		self.resizeImgs = function() {												
			var imgSizeMax = 150;
			var imgs = self.interfaceBodyContentDiv.getElementsByTagName("img");
			for (var n=0; nb = imgs.length > n; n++) {
				if ( imgs[n].getAttribute("src").indexOf("file:///C:") == 0 && imgs[n].getAttribute("src").indexOf(excludePath) == -1) {
					temp = imgs[n].getAttribute("src");
					imgs[n].setAttribute("src", url + temp.replace("file:///C:", ""));
				}
				//Si url en http, on tente de resizer
				if ( imgs[n].getAttribute("src").indexOf("http:") == 0 ) {
					//resize le img sur le onload de chaque image
					addEventToImg(imgs[n], imgSizeMax);
				}
			}
			self.timer = null;
		}

		self.timer = setTimeout(self.resizeImgs, 10);
		
		link = null;
		imgs = null;
//LCM HTA
																								
		var labels = self.interfaceBodyContentDiv.getElementsByTagName("label");
		for (var n=0; nb = labels.length > n; n++) {
			if ( labels[n].getAttribute("type") == "nsbPagination") {
				var as = labels[n].getElementsByTagName("a");
				for (var i=0; nb = as.length > i; i++) {
					as[i].onclick = function() {self.numpage= this.getAttribute("numpage");self.loadBodyContentDiv(responseXML);};
				}
				break;
			}
		}
		labels = null;
		
		self.categorySelectObj.onchange = function() {
			self.loadBodyContentDiv(self.applyFilters());
		}

		self.keywordInputObj.onkeyup = function () {
			self.loadBodyContentDiv(self.applyFilters());
		}
		self.keywordInputObj.onpaste = function () {
			self.loadBodyContentDiv(self.applyFilters());
		}
		
		self.interfaceBodyContentDiv.style.height = (document.body.offsetHeight - 100) + "px";
		self.interfaceBodyContentDiv.scrollTop=0;		
	}
	
	self.loadBodyFormAddDiv = function() {
		if ( self.displayAddForm ) {
			if ( ! App.categoryItem_parentCategoryId ) App.categoryItem_parentCategoryId = "rssFavorites"; 
			self.parentCategoryId = App.categoryItem_parentCategoryId;
			App.categoryItem_parentCategoryId = null;
			
			self.interfaceBodyFormAddDiv.innerHTML = "";
			self.interfaceBodyFormAddDiv.onclick = null;

			self.interfaceBodyFormAddDiv.innerHTML = ''
				+ '<TABLE BORDER="0" width="100%" CELLPADDING="4" CELLSPACING="0">'
				+ '	<TR>'
				+ '		<TD valign="top" align="center">'
				+ '			<TABLE cellpadding="4" cellspacing="0" bgcolor="#FFFFFF" BORDER="0" width="100%">'
				+ '				<TR>'
				+ '					<TD align="center">'
				+ '						<TABLE cellpadding="4" cellspacing="0" BORDER="0" width="100%" class="rssFeedTopBar">'
				+ '							<TR>'
				+ '								<TD valign="top" align="center">'
				+ '									<TABLE BORDER="0" width="100%">'
				+ '										<TR>'
				+ '											<TD class="rssFeedTopBarLink" align="center"><A id="addRssFeedInDesktop" href="#null"> ' + 'Ajouter ce flux RSS dans un onglet' + '</A></TD>'
				+ '											<TD class="rssFeedTopBarLink" align="center"><A id="addRssFeedInFavorites" href="#null"> ' + 'Ajouter ce flux RSS dans mes favoris' + '</A></TD>'
				+ '										</TR>'
				+ '									</TABLE>'
				+ '									</TD>'
				+ '								</TR>'
				+ '							</TABLE>'
				+ '						</TD>'
				+ '					</TR>'
				+ '				</TABLE>'
				+ '			</TD>'
				+ '		</TR>'
				+ '</TABLE>';
				
//Exemple : modXML = '<outline id="rssAdd" type="id49d3044d0d564c3da01748cdc8cb6a1e" url="http://www.lequipe.fr/Xml/actu_rss.xml"/>'
//App.addStickerToLiveSticker('<outline id="rssAdd" type="id49d3044d0d564c3da01748cdc8cb6a1e" url="http://feeds.feedburner.com/lefigaro/laune"/>')
			var as = self.interfaceBodyFormAddDiv.getElementsByTagName("a");
			for (var a=0; nba = as.length > a; a++) {
				switch ( as[a].id ) {
					case "addRssFeedInDesktop" :
						//as[a].onclick = function() {App.addStickerToLiveSticker('<outline id="rssAdd" type="' + moduleObj.getModuleType() + '" url="' + self.url + '"/>') };
						as[a].onclick = function() {App.addRssStickerToLiveSticker(self.url) };
						break;
					case "addRssFeedInFavorites" :
						as[a].onclick = function() {App.addRssStickerToRssFavorites(self.url) };
						break;
				}
			}
			as = null;
		}
	}
	
	self.loadBodyFilterDiv = function() {
		//Test filter
		self.categorySelectObj = document.createElement("select");
		self.categorySelectObj.name = "filterSelectCategories";
		
		self.keywordInputObj = document.createElement("input");
		self.keywordInputObj.name = "filterInputText";
		
		self.interfaceBodyFilterTitleDiv = document.createElement("div");
		self.interfaceBodyFilterCategoryDiv = document.createElement("div");
		self.interfaceBodyFilterKeywordDiv = document.createElement("div");
		
		self.interfaceBodyFilterTitleDiv.innerHTML = moduleObj.getText("filter items") + " : ";//moduleObj.getText("filter categories");
		self.interfaceBodyFilterTitleDiv.style.display = 'inline';
		self.interfaceBodyFilterTitleDiv.style.float = 'left';
		
		self.interfaceBodyFilterCategoryDiv.innerHTML = moduleObj.getText("filter categories") + ' :  <span></span> - ';
		self.interfaceBodyFilterCategoryDiv.style.display = 'inline';
		
		self.interfaceBodyFilterKeywordDiv.innerHTML = moduleObj.getText("filter keyword") + ' : <span></span>';
		self.interfaceBodyFilterKeywordDiv.style.display = 'inline';
				
		self.interfaceBodyFilterDiv.appendChild(self.interfaceBodyFilterTitleDiv);
		self.interfaceBodyFilterDiv.appendChild(self.interfaceBodyFilterCategoryDiv);
		self.interfaceBodyFilterDiv.appendChild(self.interfaceBodyFilterKeywordDiv);
				
		var tmp = self.interfaceBodyFilterDiv.getElementsByTagName("span")[0].parentNode.replaceChild(self.categorySelectObj, self.interfaceBodyFilterDiv.getElementsByTagName("span")[0]);
		var tmp = self.interfaceBodyFilterDiv.getElementsByTagName("span")[0].parentNode.replaceChild(self.keywordInputObj, self.interfaceBodyFilterDiv.getElementsByTagName("span")[0]);
		tmp = null;		
		
		//Categories
		if ( ! self.filterCategory ) {
			self.filterCategory = "";
		}
		
		//Charge la feuille de style pour rcuprer et trier
		var xslDoc = new ActiveXObject("Msxml2.FreeThreadedDOMDocument.4.0");
		xslDoc.async = false;
		xslDoc.loadXML("<?xml version=\"1.0\"?>"+
					"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\"><xsl:output method=\"xml\"/>" +
					"<xsl:key name=\"categorieKey\" match=\"/rss/channel/item//category\" use=\".\"/>" +
					"<xsl:template match=\"/rss\"><categories><xsl:apply-templates select=\"channel/item//category[generate-id(.)=generate-id(key('categorieKey', .)[1])]\"><xsl:sort select=\".\" data-type=\"text\" order=\"ascending\"/></xsl:apply-templates></categories></xsl:template>"+
					"<xsl:template match=\"category[. != '']\"><xsl:copy-of select=\".\"/></xsl:template>"+
					"</xsl:stylesheet>"	);
		
		//Cre le processeur avec la feuille de style et le Dom document
		var xslt = new ActiveXObject("Msxml2.XSLTemplate.4.0");
		xslt.stylesheet = xslDoc;
		delete(xslDoc);
		var xslProc = xslt.createProcessor();
		delete(xslt);
		var categoriesNode = self.completeResponseXml.cloneNode(true);
		xslProc.input = categoriesNode;
		//delete(stickersNode);
		
		//Effectue la transformation
		xslProc.transform();
		categoriesNode.loadXML(xslProc.output);
		delete(xslProc);
		
		var categories = categoriesNode.selectNodes("//category");
		
		while (self.categorySelectObj.hasChildNodes()) {
			var temp = self.categorySelectObj.removeChild(self.categorySelectObj.childNodes[0]);
		}
		temp = null;
		
		if ( categories.length == 0 ) {
			var opt = document.createElement("option");
			opt.value = "";
			opt.text = moduleObj.getText("filter undefined categories");
			self.categorySelectObj.add(opt);
			self.interfaceBodyFilterCategoryDiv.style.display='none';
		} else {
			var opt = document.createElement("option");
			opt.value = "";
			opt.text = moduleObj.getText("filter all categories");
			self.categorySelectObj.add(opt);
			
			for (var c=0; nbc = categories.length > c; c++) {
				opt = document.createElement("option");
				opt.value = categories[c].text;
				opt.text = (categories[c].text).replace("&amp;", "&") + ' (' + self.completeResponseXml.selectNodes('//category[contains(.,"'+(categories[c].text).replace(/"/g, '')+'")]').length + ")";
				if ( categories[c].text == self.filterCategory ) {
					opt.selected = true;
				}
				self.categorySelectObj.add(opt);
			}
		}
		
		( ! self.filterKeyWord ) ? "" : self.keywordInputObj.value = self.filterKeyWord;
		
		self.interfaceBodyFilterDiv.style.display='block';
		
	}
	
	//Methode qui ferme l'interface
	self.close = function() {
		//detache les evenements
		self.interfaceHeaderDiv.getElementsByTagName("img")[1].detachEvent("onclick",self.close);
		
		//Dtruits les objets (audio dans l'interface RssReader ) ....
		var objs = self.interfaceBodyDiv.getElementsByTagName("object");	
		for (var i=0; nb = objs.length > i; i++) {
			try{objs[i].Stop()}
			catch (err) {}
		}
		
		self.interfaceBodyDiv.innerHTML = "";
		
		App.removeInterfaceCurrentModule();
	}
	
	self.errorBuildHTML = function() {
		var contentDiv = document.createElement("div");
		self.titleDiv.innerHTML = _("Error");
		contentDiv.innerHTML = '<br><br><center><span class="' + self.className + 'Main" style="width:100%;height:100%">' + 		moduleObj.getText("Unable to read feed") + '</span></center><br><br><br>';
		self.interfaceBodyContentDiv.innerHTML = "";
		self.interfaceBodyContentDiv.appendChild(contentDiv);
	}
	
	self.errorRSSBuildHTML = function() {
		var contentDiv = document.createElement("div");
		self.titleDiv.innerHTML = _("Error");
		contentDiv.innerHTML = '<br><br><center><span class="' + self.className + 'Main" style="width:100%;height:100%">' + 		moduleObj.getText("Unable to read this RSS feed.<br>The url is incorrect or the feed is not valid ...") + '</span></center><br><br><br>';
		self.interfaceBodyContentDiv.innerHTML = "";
		self.interfaceBodyContentDiv.appendChild(contentDiv);
	}
	
	//########## objet utilObj methodes des filtres
	self.applyFilters = function() {
		
		responseXML = self.completeResponseXml.cloneNode(true);
		self.numpage = null;
		
		//Filter Categories
		if ( self.filterCategory != self.categorySelectObj.options[self.categorySelectObj.selectedIndex].value ) {
			self.filterCategory = self.categorySelectObj.options[self.categorySelectObj.selectedIndex].value;
		}
		if ( self.filterCategory != "" ) {
			var items = responseXML.selectNodes("/rss/channel/item[category != \"" + self.filterCategory + "\"]");
			for (var d=0; nb = items.length > d; d++) {
				var oldChild = items[d].parentNode.removeChild(items[d]);
				oldChild = null;
			}
		}
		
		//Filter Input text
		if ( self.filterKeyWord != self.keywordInputObj.value ) {
			self.filterKeyWord = self.keywordInputObj.value;
		}
		var items = responseXML.selectNodes("/rss/channel/item");
		for (var d=0; nbd = items.length > d; d++) {
			var contentStr = "";
			var titleNode = items[d].selectSingleNode("title");
			var descriptionNode = items[d].selectSingleNode("description");
			if ( descriptionNode && ( Utils.removeHTMLTags(descriptionNode.text).toUpperCase().indexOf(self.filterKeyWord.toUpperCase()) == -1 )
					&& titleNode && ( Utils.removeHTMLTags(titleNode.text).toUpperCase().indexOf(self.filterKeyWord.toUpperCase()) == -1 ) ) {
				var oldChild = items[d].parentNode.removeChild(items[d]);
				oldChild = null;
			}
		}
		return responseXML;
	}
	
	//********************************************************************************************
	//--- INIT
	//********************************************************************************************
	
	//Divs
	self.div = document.createElement("div");
	self.headerDiv = document.createElement("div");
	self.mainDiv = document.createElement("div");
	
	//Construction des div
	self.div.className = self.className + "Interface";
	self.div.style.position = "absolute";
	
	//Header
	self.interfaceHeaderDiv = document.createElement("div");
	self.interfaceHeaderDiv.className = "interfaceHeader";

	//Body
	self.interfaceBodyDiv = document.createElement("div");
	self.interfaceBodyDiv.className = self.className + "InterfaceBody";
	self.interfaceBodyDiv.id = self.className + "InterfaceBody";
	
	self.interfaceBodyFormAddDiv = document.createElement("div");
	self.interfaceBodyFormAddDiv.className = self.className + "InterfaceBodyFormAdd";
	self.interfaceBodyFormAddDiv.id = self.className + "InterfaceBodyFormAdd";
	
	self.interfaceBodyFilterDiv = document.createElement("div");
	self.interfaceBodyFilterDiv.className = self.className + "InterfaceBodyFilter";
	self.interfaceBodyFilterDiv.id = self.className + "InterfaceBodyFilter";
	
	self.interfaceBodyContentDiv = document.createElement("div");
	self.interfaceBodyContentDiv.className = self.className + "InterfaceBodyContent";
	self.interfaceBodyContentDiv.id = self.className + "InterfaceBodyContent";
	
	self.interfaceBodyButtonDiv = document.createElement("div");
	self.interfaceBodyButtonDiv.className = self.className + "InterfaceBodyButton";
	self.interfaceBodyButtonDiv.id = self.className + "InterfaceBodyButton";										
	
	self.interfaceBodyDiv.appendChild(self.interfaceBodyFormAddDiv);
	self.interfaceBodyDiv.appendChild(self.interfaceBodyFilterDiv);
	self.interfaceBodyDiv.appendChild(self.interfaceBodyContentDiv);
	self.interfaceBodyDiv.appendChild(self.interfaceBodyButtonDiv);
	
	self.buildInterface();
}
