//--------------------------------------------------------------------------------------------
//***  RSS READER ***
//--------------------------------------------------------------------------------------------

var Id49d3044d0d564c3da01748cdc8cb6a1e = function(moduleObj) {
    var self = this;
    self.nameInfo = "modules/Rssreader.js";

    var default_widget_border_width = 4;
    var default_widget_width = 468;

    //Valeurs par dfaut
    var default_backgroundColor = "#FFFFFF";
    var default_nbItems = "10";
    var default_openUrl = "0";
    var default_interface = "1";
    var default_getFavIcon = "1";
    var default_getTitle = "1";
    var default_displayMode = "titles"; //shortnews
    var default_sentinel_keyword = ["","",""];
    var default_sentinel_active = "0"; //inactive

    var firstLoad = true; //Pager
    var startIndex = 1; //Pager
    var m_readerObj = null;

    var mediaMode = false;

    var pass     = null;
    var login     = null;

    var feedUrl = null;
    var opmlUrl = null;
    var pubUrl = null;
    var wizardUrl = null;

    var stickerClass = (moduleObj.isWindowsSticker == 1) ? "sticker" : "livesticker";

    var reloadProcess = false;
    var requestPending = false;

    self.noReload = false;

    function disableRequestPending(fn) {
        return function(e) {
            requestPending = false;
            fn(e);
        }
    }

    //Disable the resizable property of the module
    moduleObj.setResizableWindowsSticker(false);

    //On force la taille du widget
    moduleObj.div.style.width=default_widget_width;

    self.interfaceObj;

    self.readerListenerObj      = { onSuccess:onReaderDataReadSuccess, onSimilar:onReaderDataReadSimilar, onFailure:onReaderError, onException:onReaderDataException };
    self.sentinelListenerObj = { onChange:onReporterChanged };

    //********************************************************************************************
    //--- PUBLIC METHODS
    //********************************************************************************************
    self.getId = function () {
        return (moduleObj.getModuleId() && (window.external.getTabs().getTabByModuleId(moduleObj.getModuleId()) != null)) ? moduleObj.getModuleId() : "id49d3044d0d564c3da01748cdc8cb6a1e";
    }

    self.getReader = function()
    {
		if (m_readerObj)
		{
			return m_readerObj;
		}

		var sentinel = window.external.getReaderEngine().sentinel( self.getId());
		if (!sentinel)
		{
			return null;
		}

		return sentinel.feed();
    }

    self.getSentinel = function()
    {
		var sentinel = window.external.getReaderEngine().sentinel( self.getId());
		if (!sentinel)
		{
			return null;
		}

		return sentinel.filter();
    }

    self.start = function() {
        if (!self.getReader()) {
            self.initReader();
        }
        self.getReader().addListener( self.readerListenerObj, moduleObj.getModuleId());
        self.getSentinel().addListener( self.sentinelListenerObj );
    }

    self.stop = function() {
        //Trace_Debug("> Begin-End ",self.nameInfo,"self.stop = function()");

        // try to stop the player of this module
        try { App.Media.stop(self.getId()); } catch (e) {}

        if (self.getReader() != null) {
            self.getReader().remListener( self.readerListenerObj);
        }
        if (self.getSentinel() != null) {
            self.getSentinel().remListener( self.sentinelListenerObj);
        }
    }

    self.unload = function() {
        //Trace_Debug("> Begin-End ",self.nameInfo,"self.unload = function()");
        self.stop();
    }

    self.close = function() {
        // try to stop the player of this module
        try { App.Media.stop(self.getId()); } catch (e) {}

        if (moduleObj.getModuleId()) {
            self.unload();
        }

        self.closeReader();
    }

    self.reloadHeader = function() {
        //Trace_Debug("> Begin-End ",self.nameInfo,"self.reloadHeader = function()");
        self.buildHeaderDiv();
    }

    self.reloadBody = function() {
        //Trace_Debug("> Begin-End ",self.nameInfo,"self.reloadBody = function()");
        //Permet de ne pas modifier l'affichage mme si self.reloadBody est appel
        // -> utilis depuis le dialogue du formulaire de la coregistration, par ex

        if (self.noReload) {
            return;
        }
        reloadProcess = true;
        firstLoad = true;
        startIndex = 1;
        self.buildModule();
    }

    self.buildSettings = function() {
        //Trace_Debug("> Begin-End : ",self.nameInfo,"self.buildSettings = function()");
        self.buildSettingsDiv();
    }

    self.buildSentinels = function() {
        //Trace_Debug("> Begin-End : ",self.nameInfo,"self.buildSettings = function()");
        self.buildSentinelsDiv();
    }

    //Methode qui affiche l'interface
    self.displayInterface = function(urlItem) {
        //Trace_Debug("> Begin-End ",self.nameInfo,"self.displayRssreaderInterface = function(urlItem)");
        //Trace_Debug("> urlItem " + urlItem,self.nameInfo,"self.displayRssreaderInterface = function(urlItem)");
        self.titleInterface = document.createElement("label");
        self.titleInterface.innerHTML = moduleObj.getModNodeValue("/title");

        self.displayAddForm = null;
        if ( ! moduleObj.getModuleId() && ! moduleObj.getModNodeValue("/@outlineId") ) {
            //self.displayAddForm = true;
        }

        try {
            self.interfaceObj = new RssreaderInterface(self, moduleObj);
        } catch(err) {
            moduleObj.includeJs("RssReaderInterface.js");
            self.interfaceObj = new RssreaderInterface(self, moduleObj);
        }

        App.displayCurrentModuleInterface (self.interfaceObj, urlItem);
        //self.interfaceObj.interfaceBodyDiv.style.height = self.interfaceObj.interfaceBodyDiv.parentNode.parentNode.style.height ;

    }

    //Methode qui retourne les liens qui apparaissent dans le menu contextuel d'une categorie pouvant contenir cet element
    self.getNavTabMenu = function(navObj) {
        if ( navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_url") && navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_url") != "" ) {
            self.displayModuleToAdd(navObj);
            return false;
        } else {
            var tab = ["",
                [
                    [_("Add RSS feed")],
                    ["<span class=\"navContextMenu_Libelle\">" +_("Url") + " : </span><input class=\"navContextMenu_input\" type=\"text\" maxLength=\"255\" content=\"rssUrl\">"]
                ],[
                    ["<input type=\"submit\" value=\"" + _("Preview") + "\">", function() {
                        if ( navObj.navContextMenuDiv.getElementsByTagName("input")[0].value != "" ) {
                            self.displayModuleToAdd(navObj);
                        }
                    }],
                    ["<input type=\"button\" value=\"" + _("Cancel") + "\">", function() {navObj.hideNavContextMenu();}]
                ]
            ];
            return tab;
        }
    }

    self.displayModuleToAdd = function (navObj, displayParams) {
        var title = [];
        var nodeSelectList = [];
        var attStrValue = [];
        var attStrText = [];
        var selectedValue = [];
        var baseNode = null;

        var outline_id = outline_action= "";

        if ( navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_id") ) {
            outline_id = navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_id");
        }
        if ( navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_action") ) {
            outline_action = navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_action");
        }

        if (navObj.navContextMenuDiv && navObj.navContextMenuDiv.getElementsByTagName("input").length > 0 ) {
            if ( navObj.navContextMenuDiv.getElementsByTagName("input")[0].getAttribute("content") && navObj.navContextMenuDiv.getElementsByTagName("input")[0].getAttribute("content").toUpperCase()=="RSSURL") {
                navObj.navContextMenuOpenerOutlineDiv.setAttribute("outline_url", navObj.navContextMenuDiv.getElementsByTagName("input")[0].value);
            }
        }

        var contentDiv = document.createElement("div");

        App.newModuleObj = new Module( {type : moduleObj.getModuleType()
                , title : ""
                , url : navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_url")
                , width : navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_width")
                , height : navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_height")
                } );
        contentDiv.appendChild(App.newModuleObj.getDiv());

        if (outline_id.toUpperCase() == "RSSADD"  || outline_action.toUpperCase() == "RSSADD" ) {
            var divSentinelLine = document.createElement("div");

            divSentinelLine.innerHTML = '<div><table class="rssreaderMain"><tr><td valign="center" colspan="2"><img src="' + APP_IMG_PATH + '/mod/bt_sentinel_click.gif" width="14" height="14">&nbsp;' + moduleObj.getText("Sentinel") + '</td></tr><tr><td valign="center"><input id="sentinelInput" type="checkbox"></td><td valign="top">' + moduleObj.getText("You will be notified by a desktop alert for all new article") + '</td></tr></table></div>';

            contentDiv.appendChild(divSentinelLine);

            var rssAddSentinelInputs = contentDiv.getElementsByTagName("input")
                for (var i=0; nb = rssAddSentinelInputs.length > i ; i++ ) {
                    if ( rssAddSentinelInputs[i].getAttribute("id") == "sentinelInput" ) {
                        self.rssAddSentinelInput = rssAddSentinelInputs[i];
                    }
                }
        }

        navObj.setContextMenuDiv( [""
            ,[ ["TABS_SELECT"] ,[contentDiv]]
            ,[
                ["<input type=\"submit\" value=\"" + _("Add") + "\">", function() {
                    var outline_id = "";
                    if ( navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_id") ) {
                        outline_id = navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_id");
                    }

                    if (outline_id.toUpperCase() == "RSSADD"  || outline_action.toUpperCase() == "RSSADD" ) {
                        //case rssAdd : le selecteur propose de slectionner le desktop
                        App.newModuleObj.setModNodeValue ("/settings/sentinel/active", (self.rssAddSentinelInput.checked?"1":"0"));
                        App.addStickerToDesktop();
                        navObj.hideNavContextMenu();
                        //On remet a "" l'url
                        if (outline_id.toUpperCase() == "RSSADD") {
                            navObj.navContextMenuOpenerOutlineDiv.setAttribute("outline_url", "");
                        }
                    }
                }] , ["<input type=\"button\" value=\"" + _("Cancel") + "\">", function() {
                    navObj.hideNavContextMenu();

                    var outline_id = "";
                    if ( navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_id") ) {
                        outline_id = navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_id");
                    }

                    if ( navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_type").toUpperCase() == "CATEGORIES"
                            || navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_type").toUpperCase() == "CATEGORY" ) {
                        //case rssfavorites : le selecteur propose de slectionner la catgorie
                        navObj.navContextMenuOpenerOutlineDiv.setAttribute("outline_url", "");
                    } else {
                        if ( outline_id.toUpperCase() == "RSSADD" ) {
                            //case rssAdd : le selecteur propose de slectionner le desktop
                            navObj.navContextMenuOpenerOutlineDiv.setAttribute("outline_url", "");
                        }
                    }
                }]
            ]
        ]);
        div = null;
        navObj.navContextMenuDiv.style.display='block';
    }

    //Methode qui affiche le menu contextuel de la Nav sur le click sur l'element
    self.setNavContextMenu = function(navObj, action) {
        switch (action.toUpperCase()) {
            case "ADDONDESKTOP":
                //self.reloadBody();
                self.displayModuleToAdd(navObj);
            break;
            case "RENAME":
                navObj.setContextMenuDiv(["",
                    [
                        [_("Rename")],
                        ["<span class=\"navContextMenu_Libelle\">" +_("Title") + " : </span><input class=\"navContextMenu_input\" type=\"text\" maxLength=\"100\" value=\"" + navObj.navContextMenuOpenerOutlineDiv.getElementsByTagName("SPAN")[0].innerText + "\">"]
                    ],[
                        ["<input type=\"submit\" value=\"" + _("Save") + "\">", function() {if ( navObj.navContextMenuDiv.getElementsByTagName("input")[0].value != "" ) {navObj.renameCategoryItem(navObj.navContextMenuDiv.getElementsByTagName("input")[0].value);navObj.hideNavContextMenu()}}],
                        ["<input type=\"button\" value=\"" + _("Cancel") + "\">", function() {navObj.hideNavContextMenu();}]
                    ]
                ]);
            break;
            case "REMOVE":
                navObj.setContextMenuDiv( [""
                    [
                        [_("Remove")],
                        [_("Are you sure you want to remove ?")]
                    ],[
                        ["<input type=\"submit\" value=\"" + _("Yes") + "\">", function() {navObj.removeCategoryItem();navObj.hideNavContextMenu()}],
                        ["<input type=\"button\" value=\"" + _("No") + "\">", function() {navObj.hideNavContextMenu();}]
                    ]
                ]);
            break;
            default :
            var tabParams = ["",
                [
                    [_("Read feed"),  function() { navObj.displayModuleInterface();navObj.hideNavContextMenu() }],
                    [_("Add on desktop"),  function() {
                        navObj.navContextMenuOpenerOutlineDiv.setAttribute("outline_action", "RSSADD")
                            self.displayModuleToAdd(navObj);
                        navObj.navContextMenuOpenerOutlineDiv.setAttribute("outline_action", "")
                }] , [_("Add this feed on Windows desktop"),  function() { window.external.createStickerByOID(navObj.getOutlineNode({type:navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_type")
                        , title:navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_text")
                        , url:navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_url")
                        , icon:navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_icon")
                        , width:navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_width")
                        , height:navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_height")
                        , created:new Date().toGMTString()}), 350, 200); navObj.hideNavContextMenu(); }],
                    /*, [_("Add to my favorites"), function() {
                      self.displayModuleToAdd(navObj);
                      }]*/
                    ["hr"],
                    [_("Rename"), function() { navObj.displayNavContextMenu(navObj.navContextMenuOpenerOutlineDiv, "Rename") }],
                    [_("Remove"), function() { navObj.displayNavContextMenu(navObj.navContextMenuOpenerOutlineDiv, "Remove") }]
                ]
            ];
            //si element en ligne (pas d'id)
            if ( ! navObj.navContextMenuOpenerOutlineDiv.getAttribute("outline_id") ) {
                //Suppression de lignes
                tabParams[1].splice(5,1);
                tabParams[1].splice(4,1);
                tabParams[1].splice(3,1);
            } else {
                //tabParams[1].splice(3,1);
            }
            navObj.setContextMenuDiv(tabParams);
            break;
        }

        //True pour afficher le menu contextuel
        return true;
    }

    self.getModNodeValue = function(nodeName) {
        return moduleObj.getModNodeValue("/"+nodeName);
    }

    self.getModAttributeValue = function(attributeName) {
        return moduleObj.modNode.getAttribute(attributeName);
    }

    // show a specific page in the module
    self.view = function(param) {
        if(param=="selectFeed") {
            self.createWizard(null,null,{cancelMethod:0, checkSentinel:false})
        }
    }

    //********************************************************************************************
    //--- PRIVATE METHODS
    //********************************************************************************************

    self.buildModule = function() {
        //Trace_Debug("> Begin : ",self.nameInfo,"function buildModule()");
        moduleObj.setSentinelsService(true);
        try { App.Media.stop(self.getId()); } catch (e) {}

        if ( window.external.getAppSentinel()==="1" ) {
            moduleObj.setSentinelsActive((self.getSentinelState() == 0 )?false:true);
        } else {
            moduleObj.setSentinelsActive(false);
        }

        self.loadContent();

        //Aprs la construction du module (on connait alors la largeur des boutons)
        //moduleObj.setWindowsStickerWidth("370");

        //Trace_Debug("> End ",self.nameInfo,"function buildModule()");
    }

    self.getIconObj = function() {
        var iconImage = document.createElement("img");

        var urlIcon = moduleObj.getUrlIcon();

        if (urlIcon == '') {
            urlIcon = APP_MODULES_PATH + "/" + moduleObj.getModuleType() + "/img/default_icon.gif";
        }

        iconImage.src = urlIcon;

        if (moduleObj.getModNodeValue("/settings/getFavIcon") == "1") {
            if (self.getReader() != null) {
                self.getReader().faviconRequest( new ImageListener( iconImage, 16, 16));
            }
        }

        return iconImage;
    }


    self.buildHeaderDiv = function() {
        ////Trace_Debug("> Begin ",self.nameInfo,"self.buildHeaderDiv = function()");
        //Traitement de l'icone
        // Ajout HTA 13/04/20007
        // si icon precise dans le main.xml alors on prend celle la
        var iconImage = self.getIconObj();

        var modTitle = moduleObj.getModNodeValue("/title");
        self.linkText = document.createTextNode(modTitle);

        var tmpDiv = document.createElement("div");

        tmpDiv.appendChild(iconImage);

        if ((moduleObj.isRegistered() ) && (!moduleObj.isWindowsSticker)) {
            var link = document.createElement('a');

            link.href = "#1";
            //link.onclick = function() { App.getModule(moduleObj.moduleId).contentObj.displayInterface(''); };
            link.onclick = function() { self.displayInterface(''); };

            link.appendChild(self.linkText);

            tmpDiv.appendChild(link);

            link = null;
        } else {
            tmpDiv.appendChild(self.linkText);
        }

        moduleObj.setHeader(tmpDiv);

        tmpDiv      = null;
        iconImage = null;
        //Trace_Debug("> End ",self.nameInfo,"self.buildHeaderDiv = function()");
    }

    self.buildItemsDiv = function(itemsDiv, docXml) {
        var xsltItems = (  moduleObj.getModNodeValue("/settings/xsltReader")!=null && moduleObj.getModNodeValue("/settings/xsltReader")!="") ? APP_MODULES_PATH + "/ihm/xslt/" + moduleObj.getModNodeValue("/settings/xsltReader") : APP_MODULES_PATH + "/"+moduleObj.getModuleType()+"/xsl/rssreader_items.xsl";

        var xslResult = applyXslTemplate( docXml, xsltItems, [ ["mod_id", moduleObj.getModuleId()]
                , ["mod_settings_displayMode", moduleObj.getModNodeValue("/settings/displayMode")]
                , ["mod_settings_openUrl", moduleObj.getModNodeValue("/settings/openUrl")]
                , ["mod_settings_startIndex", startIndex]
                , ["mod_settings_nbItems", moduleObj.getModNodeValue("/settings/nbItems")]
                , ["mod_settings_thumbnailLink", moduleObj.getModNodeValue("/settings/thumbnailLink")]
                , ["isWindowsSticker", (moduleObj.isWindowsSticker ? "1" : "0")]
                , ["rssReaderPath", "../"+moduleObj.getModuleType()]
                , ["text_feed_empty", moduleObj.getText("feed empty")]
                , ["text_read_item", moduleObj.getText("Read item")]
                , ["item_class", moduleObj.getModNodeValue("/settings/itemClass")]
                , ["language", window.external.getAppLang()]
                ]);
        itemsDiv.html( xslResult); xslResult = null;

        if (pubUrl) {
            itemsDiv.append( '<iframe id="iframe_pub2" frameborder=0 scrolling="no" src="'+pubUrl+'"></iframe>');
        }

        var urlFeed = moduleObj.getModNodeValue("/link");
        var urlBase = moduleObj.getModNodeValue("/link");

        _$(".s", itemsDiv).each( function() {
                var _this = _$(this);
                if (_this.html() == '') {
                    _this.hide();
                }
                var as = _$("a", _this);
                if (as.length > 0){
                    _this.click( function(){
                        //tracking
                        self.track({event:'click_enclosure',action:'read'});
                    });
                }
            });

        _$(".t", itemsDiv).each( function() {
                _$(this).click( function(){
                    //tracking
                    self.track({event:'click_title'});
                });
            });

        _$("img[url]", itemsDiv).each( function() {
                if (this.url.indexOf("http") != 0) {
                    // if the url is an abolute path
                    if (this.url.charAt(0) == '/') {
                        this.url = urlBase + this.url;
                    } else { // relative path
                        this.url = urlFeed + this.url; // ???
                    }
                }
            });

        _$(".rssview .thumbnail", itemsDiv).each( function() {
                if (this.thumbnail.indexOf("http") != 0) {
                    // if the url is an abolute path
                    if (this.thumbnail.charAt(0) == '/') {
                        this.src = urlBase + this.thumbnail;
                    } else { // relative path
                        this.src = urlFeed + this.thumbnail; // ???
                    }
                }
            });

        //Resize images
        _$(".rssview .i", itemsDiv).each(function() {
            var maxWidth = maxHeight = 80;
            var first_maxW = first_maxH = 150;

            var container = _$(this);
            if (container.parents('div').eq(0).attr('class').indexOf('first') > -1) {
                maxWidth = first_maxW;
                maxHeight = first_maxH;
            }

            var imgProduct = new Image();

            var realWidth, realHeight;

            imgProduct.onload = function() {
                realWidth = imgProduct.width;
                realHeight = imgProduct.height;

                if (maxWidth < realWidth || maxHeight < realHeight)
                {
                    var ratio = realHeight/realWidth;
                    if (ratio > 1)
                    {
                        var newWidth = Math.min(maxHeight/ratio, maxWidth);
                        var newHeight = newWidth*ratio;

                        imgProduct.height = newHeight;
                        imgProduct.width = newWidth;
                    }
                    else
                    {
                        var newHeight = Math.min(maxWidth*ratio, maxHeight);
                        var newWidth = newHeight/ratio;
                        imgProduct.width = newWidth;
                        imgProduct.height = newHeight;
                    }
                }

                var Img = _$(imgProduct);
                if ((!container.attr('thumbnailLink')) || (container.attr('thumbnailLink') == "0"))
                {
                    Img.attr({'realWidth':realWidth,'realHeight':realHeight})
                        .css({'cursor':'url('+APP_MODULES_PATH + '/'+moduleObj.getModuleType()+'/img/zoom-in.cur)'})
                        .click( function(){
                            self.showMedia(Img.attr('src'), 'image');
                            //tracking
                            self.track({event:'click_enclosure',action:'image'});});
                } else {
                    //Set the thumbnail action as the action of the link
                    var links = container.parents(".item").find(".title a");

                    if (links.length != 0) {
                        Img.css({cursor:"pointer"})
                            .click( function(link) { return function() {
                                window.external.navigate( link.attr("link"));
                                //tracking
                                self.track({event:'click_enclosure',action:'image'});
                                        }
                                    }(links.eq(0)));
                    }
                }
                container.append(Img);
            } ;

            imgProduct.onerror = function() {
                container.css({'display':'none'});
            } ;

            imgProduct.src = container.attr('thumbnail');
        });

        _$(".rssview img.audio", itemsDiv)
            .css({'cursor':'pointer'})
            .click( function(){
                self.showMedia(this.url, this.mimetype);
                //tracking
                self.track({event:'click_enclosure',action:'audio'});})
            .mouseover(function(){_$(this).attr('src', APP_MODULES_PATH + '/'+moduleObj.getModuleType()+'/img/' + window.external.getAppLang() + '/bt_ecouter_off.png')})
            .mouseout(function(){_$(this).attr('src', APP_MODULES_PATH + '/'+moduleObj.getModuleType()+'/img/' + window.external.getAppLang() + '/bt_ecouter_on.png')});

        _$(".rssview img.video,.rssview img.flash", itemsDiv)
            .css({'cursor':'pointer'})
            .click( function(){
                self.showMedia(this.url, this.mimetype);
                //tracking
                self.track({event:'click_enclosure',action:'video'});})
            .mouseover(function(){_$(this).attr('src', APP_MODULES_PATH + '/'+moduleObj.getModuleType()+'/img/' + window.external.getAppLang() + '/bt_video_off.png')})
            .mouseout(function(){_$(this).attr('src', APP_MODULES_PATH + '/'+moduleObj.getModuleType()+'/img/' + window.external.getAppLang() + '/bt_video_on.png')});

        _$(".rssview img.file", itemsDiv)
            .css({'cursor':'pointer'})
            .click( function(){
                window.external.navigate(this.url);
                //tracking
                self.track({event:'click_enclosure',action:'file'});})
            .mouseover(function(){_$(this).attr('src', APP_MODULES_PATH + '/'+moduleObj.getModuleType()+'/img/' + window.external.getAppLang() + '/bt_telecharger_off.png')})
            .mouseout(function(){_$(this).attr('src', APP_MODULES_PATH + '/'+moduleObj.getModuleType()+'/img/' + window.external.getAppLang() + '/bt_telecharger_on.png')});
        /*
        //TRACK
        _$("", alertDiv).each(function(){

        };*/

        /*
        _$("", itemsDiv).each(function(){

        };
        */
    }


    self.buildMainDiv = function(docXml) {

        var body = _$('<div id="rssreader_body"><div id="alert" style="background-image:url('+APP_MODULES_PATH + '/'+moduleObj.getModuleType()+'/img/toolbar_bk.jpg)"/><div id="items" class="rssreaderMain"/><div id="pagination" style="background-image:url('+APP_MODULES_PATH + '/'+moduleObj.getModuleType()+'/img/toolbar_bk.jpg)"/></div>');
        var alertDiv = _$('#alert',body);
        var paginationDiv = _$('#pagination',body);
        var itemsDiv = _$('#items',body);
        alertDiv.append('<input type="checkbox" id="checkboxAlert"/><div class="text"></div><a href="#" id="sentinelLink">'+moduleObj.getText("Expert mode")+'</a>');
        paginationDiv.append('<script language="JavaScript"src="'+APP_MODULES_PATH + "/"+moduleObj.getModuleType()+"/js/jquery.pagination.js"+'"></script>');
        itemsDiv.addClass(stickerClass).attr( "id", "rssreaderMain_" + moduleObj.getModuleId());
        itemsDiv.append('<script language="JavaScript"src="'+APP_MODULES_PATH + "/"+moduleObj.getModuleType()+"/js/resize.js"+'"></script>');

        //Alert toolbar
        switch (self.getSentinelState()) {
            case 1 :
                _$('#checkboxAlert', alertDiv).attr('checked', 'true');
                _$('.text', alertDiv).html('<label for="checkboxAlert">'+moduleObj.getText("sentinel_msg_1")+'</label>');
                break;
            case 2 :
                _$('#checkboxAlert', alertDiv).attr('checked', 'true');
                _$('.text', alertDiv).html('<label for="checkboxAlert">'+moduleObj.getText("sentinel_msg_2")+'</label>');
                break;
            default :
                _$('.text', alertDiv).html('<label for="checkboxAlert">'+moduleObj.getText("sentinel_msg_1")+'</label>');
        }

        _$('#checkboxAlert', alertDiv).bind('click', function() {
                var checkboxAlert = false;
                if (_$('#checkboxAlert', alertDiv).attr('checked')) {
                    checkboxAlert = true;
                }
                self.alertCheckAction = true;
                switch (self.getSentinelState()) {
                    case 0 :
                    case 1 :
                        self.getSentinel().setState(checkboxAlert);
                        self.getSentinel().setKeyword( new Array);
                        break;
                    case 2 :
                        self.getSentinel().setState(checkboxAlert);
                        break;
                }
                //tracking
                self.track({event:'click_sentinel',action:(checkboxAlert?'on':'off')});
            });
        _$('#sentinelLink', alertDiv).bind('click', function() {
                _$('img[sentinel_img*="bt_sentinel"]', moduleObj.modHeaderButtonsDiv).trigger('click');
                //tracking
                self.track({event:'click_expert_mode', action:'open'});
            });

        //Pagination toolbar
        var nb_items = docXml.selectNodes('//item').length;
        var items_per_page = parseInt(moduleObj.getModNodeValue("/settings/nbItems"), 10);

        var cb = function(page_index){
            startIndex = (page_index*items_per_page)+1;
            if (page_index > 0 || ! firstLoad) {
                self.buildItemsDiv(itemsDiv, docXml);
                firstLoad = false;
                //tracking
                self.track({event:'click_sentinel',page:page_index});
            }
            return false;
        }
        self.setPagination(_$('#pagination', body)
                            , nb_items
                            , items_per_page
                            , cb);

        self.buildItemsDiv(itemsDiv, docXml);

        self.setBody(body.get(0));

    }

    self.setPagination = function(divItem, nb_items, items_per_page, cb) {
        divItem.pagination(nb_items, {'callback': cb
                                                ,'items_per_page':items_per_page
                                                ,'num_display_entries':0
                                                ,'num_edge_entries':0
                                                ,'prev_text':'<< ' + moduleObj.getText("previous")
                                                ,'prev_show_always':false
                                                ,'next_text':moduleObj.getText("next") + ' >>'
                                                ,'next_show_always':false});
    }

    self.showMedia = function(url,type) {
        if (url) self.showMedia_url = url;
        if (url) self.showMedia_type = type;
        if (_$('#rssreader_body').length == 0){
            // Cas ou le showMedia est appel depuis une alerte alors que le widget est ferm ...

            setTimeout(self.showMedia , 1000);
            return;
        }

        if (!url) url = self.showMedia_url;
        if (!type) type = self.showMedia_type;

        var MyPlayer = null;
        var displayDivItem = _$('#rssreader_body');
        var positonFromTop = getTop(displayDivItem[0]);
        var bodyMedia = _$('<div id="media" style="width:'+ (+default_widget_width + default_widget_border_width) + 'px">'
                            + '<div id="overlay" style="top:'+positonFromTop+'px;width:'+displayDivItem.width()+'px;height:'+displayDivItem.height()+'px"></div>'
                            + '<div id="stickerBodyMediaPlayer" style="top:'+positonFromTop+'px;width:'+displayDivItem.width()+'px;height:'+displayDivItem.height()+'px"><table width="100%" height="100%" border="0" '
                            + ' onresize="javascript:'
                            + ' var table_h = this.offsetHeight;'
                            + ' var rssreader_body_h = _$(\'#rssreader_body\').height();'
                            + ' var diff_h = table_h - rssreader_body_h;'
                            + ' if (diff_h > 0) {'
                            + '     _$(\'#rssreader_body\').append(\'<div id=emptyLine style=height:\'+(diff_h)+\'px>&nbsp;</div>\');'
                            + '  };"'
                            + '><tr><td align="center" valign="middle" id="media_container"></td></tr>'
                            + '</table></div>'
                            + '</div>');

        var widthMedia = _$("#mod_"+self.getId()).width()-60;

        if (type == "image") {
            MyPlayer = {stop:function(){}};

            var thumbItem = _$('img[src="'+url+'"]');

            maxW = maxH = widthMedia;

            var thumbItemWidth = thumbItem.attr('realWidth');
            var thumbItemHeight = thumbItem.attr('realHeight');

            if (thumbItemWidth >= thumbItemHeight) {
                if (thumbItemWidth > maxW) {
                    thumbItemHeight = (thumbItemHeight * maxW) / thumbItemWidth;
                    thumbItemWidth = maxW;
                }
            } else if (thumbItemHeight > maxH) {
                thumbItemWidth = (thumbItemWidth * maxH) / thumbItemHeight;
                thumbItemHeight = maxH;
            }

            var img = new Image();
            img.src = url;
            img.className = 'stickerBodyOverlayImg';
            img.style.width = thumbItemWidth;
            img.style.height = thumbItemHeight;
            img.style.marginTop = '5px';

            _$('#media_container', bodyMedia)[0].appendChild(img);

        } else if ((type == "audio") || (type == "video") || (type == "flash")) {
            MyPlayer = new nsbMediaPlayer({url:url, type:type, width:widthMedia});

            MyPlayer.setFlvPlayer("../ihm/mediaplayer/mediaplayer.swf");
            MyPlayer.mapFormat({mp3:"winmedia"});

            _$('#media_container', bodyMedia).append(MyPlayer.htmlElement);

            MyPlayer.start();
        } else { // file, ...
            window.external.navigate( url); return;
        }

        _$('#media_container', bodyMedia).append( '<input type="button" class="stickerBodyOverlayBackButton mainFormButton_input" style="margin:5px 0 5px 0" value="' + moduleObj.getText("back") + '"/>')
        _$('#iframe_pub2').css('visibility', 'hidden');
        _$('.stickerBodyOverlayBackButton', bodyMedia).click(function(){
                                        bodyMedia.hide();
                                        MyPlayer.stop();
                                        mediaMode = false;
                                        _$('#emptyLine').remove();
                                        _$('#iframe_pub2').css('visibility', 'visible');
                                    });
        mediaMode = true;

        displayDivItem.append(bodyMedia);
        bodyMedia.show();

        _$('#overlay', bodyMedia).height(displayDivItem.height());
    }

    //Reconstruit le module sans recharger les donnes (resize des images ...)
    //Mthode prsente si ncessaire uniquement (xcute lors du raffichage de l'onglet dans lequel il est contenu)
    self.rebuild = function(){
        if (self.noReload) {
            return;
        }
        self.start();
        self.buildModule();
    }

    self.initReader = function() {

        try {
            var tab   = window.external.getTabs().getTabByModuleId(moduleObj.getModuleId());

            var tabId = (!tab) ? null : tab.documentElement.getAttribute("id");

            opmlUrl   = addUrlParameter( moduleObj.getModNodeValue("/opmlUrl"), {mod:moduleObj.getModuleId(), tab:tabId, cid:moduleObj.getModNodeValue("/@cid")});
            feedUrl   = Utils.getIdentUrl( moduleObj.getModNodeValue("/url"), pass, login);
            pubUrl    = addUrlParameter( moduleObj.getModNodeValue("/pubUrl"), {mod:moduleObj.getModuleId(), tab:tabId, cid:moduleObj.getModNodeValue("/@cid"), mod_type:moduleObj.getModuleType(), mod_revision:window.external.getModuleVersion(), v:window.external.getLibDockVersion});
            wizardUrl = addUrlParameter( moduleObj.getModNodeValue("/wizardUrl"), {mod:moduleObj.getModuleId(), tab:tabId, cid:moduleObj.getModNodeValue("/@cid")});

            if (!feedUrl) {
                return false;
            }

            //S'il a un id et qu'il est enregistr dans les prefs
            if (! moduleObj.getModuleId() || !tab) {
                /****************** Cration de l'objet Reader *****************/
                //Le module n'est pas enregistr -> on ne fait que lire le flux
                m_readerObj = window.external.getReaderEngine().getReader("id49d3044d0d564c3da01748cdc8cb6a1e", feedUrl, "rss_mem");

                self.getReader().addListener( self.readerListenerObj, moduleObj.getModuleId());
            } else {
                /****************** Cration de l'objet Reader  partir de la configuration stocke dans le noeud xml du module *****************/
                var rssFeed = window.external.getReaderEngine().initRssSentinel(moduleObj.getModuleNode() );
                m_readerObj = null;

                // Inscrit le module  la reception des messages du reader
                if (self.getReader() != null) {
                    self.getReader().addListener( self.readerListenerObj, moduleObj.getModuleId());
                }

                // Inscrit le module  la reception des messages de la sentinel
                if (self.getSentinel() != null) {
                    self.getSentinel().addListener( self.sentinelListenerObj);
                    self.getSentinel().addUserParam("feed_type", "rss");
                    self.getSentinel().addUserParam("item_class", moduleObj.getModNodeValue("/settings/itemClass"));

                    if (tab != null) {
                        self.getSentinel().addUserParam("category", tab.documentElement.getAttribute("text"));
                    }
                }
            }

            //Sauvegarde le "mod" dans les prefs, s'il y a eu des modifs
            moduleObj.saveMod();

            return true;
        } catch(error) {
            moduleObj.error = true;

            self.loadErrorContent();
        }
    }

    self.closeReader = function()
    {
        try {
			var sentinel = window.external.getReaderEngine().sentinel( self.getId());
			if (!sentinel)
			{
				return;
			}
			sentinel.dispose();

        } catch(err) {
            error("Unable to delete reader object from an rss module."); error(err);
        }
    }

    self.buildSettingsDiv = function() {
        self.settingsDiv = document.createElement("div");
        self.settingsDiv.className = 'rssreaderSettings';
        self.settingsDiv.id = self.settingsDiv.className + "_" + moduleObj.getModuleId();
        self.settingsDiv.style.width = default_widget_width + default_widget_border_width + 'px';
        self.settingsDiv.style.backgroundImage = 'url(file://'+ APP_MODULES_PATH + '/' + moduleObj.getModuleType()+'/img/settings_background.jpg)';

        //Bar title
        self.bartitleDiv = document.createElement("div");
        self.bartitleDiv.className = "rssreaderSettingsBarTitle";
        self.bartitleDiv.innerHTML = "<div>" + moduleObj.getText("My settings") + " : </div>";

        //encoder en html le value
        self.titleDiv = document.createElement("div");
        self.titleDiv.className = "rssreaderSettingsTitle";
        self.titleDiv.id = self.titleDiv.className + "_" + moduleObj.getModuleId();
        self.titleDiv.setAttribute("typeOptions", "7");
        self.titleDiv.setAttribute("nodePath", "/title");
        self.titleDiv.innerHTML = "<span>" + moduleObj.getText("Title") + " : </span>";

        self.inputTitle = document.createElement("input");
        self.inputTitle.className = "rssreaderSettingsInputTitle";
        self.inputTitle.id = self.inputTitle.className + "_" + moduleObj.getModuleId();
        self.inputTitle.type = "text";
        self.inputTitle.style.width = "250px";
        self.inputTitle.maxlength = "255";
        self.inputTitle.contentEditable = "true";
        self.inputTitle.value = moduleObj.getModNodeValue("/title");

        self.titleDiv.appendChild(self.inputTitle);

        self.urlDiv = document.createElement("div");
        self.urlDiv.className = "rssreaderSettingsUrl";
        self.urlDiv.id = self.urlDiv.className + "_" + moduleObj.getModuleId();
        self.urlDiv.setAttribute("typeOptions", "6");
        self.urlDiv.setAttribute("nodePath", "/url");
        self.urlDiv.style.verticalAlign = "middle";
        self.urlDiv.innerHTML = "<span>" + moduleObj.getText("Url") + " : </span>";

        self.inputUrl = document.createElement("label");
        self.inputUrl.innerHTML = moduleObj.getModNodeValue("/url");
        self.inputUrl.style.fontWeight = "normal";
        self.inputUrl.style.width= "249px";
        self.inputUrl.style.overflow="hidden";
        self.inputUrl.style.wordWrap = "break-word";
        self.inputUrl.style.verticalAlign = "middle";
        self.inputUrl.style.padding = "3px 0 3px 0";

        self.urlDiv.appendChild(self.inputUrl);

        self.displayModeDiv = document.createElement("div");
        self.displayModeDiv.className = "rssreaderSettingsDisplayMode";
        self.displayModeDiv.id = self.displayModeDiv.className + "_" + moduleObj.getModuleId();
        self.displayModeDiv.setAttribute("typeOptions", "7");
        self.displayModeDiv.setAttribute("nodePath", "/settings/displayMode");
        self.displayModeDiv.innerHTML = "<span>" + moduleObj.getText("Display mode") + " : </span>";

        self.selectDisplayModeItems = document.createElement("select");
        self.selectDisplayModeItems.className = "rssreaderSettingsSelectDisplayModeItems";
        self.selectDisplayModeItems.id = self.selectDisplayModeItems.className + "_" + moduleObj.getModuleId();

        var tab_labels = [moduleObj.getText("Display mode Titles"), moduleObj.getText("Display mode Shortnews")];
        var tab_values = ["titles", "shortnews"];
        var nb = tab_values.length;
        for (var i=0;i<nb;i++) {
            var optionSelect = document.createElement("option");
            optionSelect.value = tab_values[i];
            optionSelect.innerHTML = tab_labels[i];
            if ( tab_values[i] == moduleObj.getModNodeValue("/settings/displayMode")){ optionSelect.selected = true; }
            self.selectDisplayModeItems.appendChild(optionSelect);
        }
        optionSelect = null;
        tab_values=null;
        nb=null;

        self.displayModeDiv.appendChild(self.selectDisplayModeItems);

        self.nbDiv = document.createElement("div");
        self.nbDiv.className = "rssreaderSettingsNb";
        self.nbDiv.id = self.nbDiv.className + "_" + moduleObj.getModuleId();
        self.nbDiv.setAttribute("typeOptions", "7");
        self.nbDiv.setAttribute("nodePath", "/settings/nbItems");
        self.nbDiv.innerHTML = "<span>" + moduleObj.getText("Nb displayed titles") + " : </span>";

        self.selectNbItems = document.createElement("select");
        self.selectNbItems.className = "rssreaderSettingsSelectNbItems";
        self.selectNbItems.id = self.selectNbItems.className + "_" + moduleObj.getModuleId();

        var tab_values = ["1","2","3","4","5","10","15","20","25","30"];
        var nb = tab_values.length;
        for (var i=0;i<nb;i++){
            var optionSelect = document.createElement("option");
            optionSelect.value = tab_values[i];
            optionSelect.innerHTML = tab_values[i];
            if ( tab_values[i] == moduleObj.getModNodeValue("/settings/nbItems")){ optionSelect.selected = true; }
            self.selectNbItems.appendChild(optionSelect);
        }
        optionSelect = null;
        tab_values = null;
        nb = null;

        self.nbDiv.appendChild(self.selectNbItems);

        self.openUrlDiv = document.createElement("div");
        self.openUrlDiv.className = "rssreaderSettingsOpenUrl";
        self.openUrlDiv.id = self.openUrlDiv.className + "_" + moduleObj.getModuleId();
        self.openUrlDiv.setAttribute("typeOptions", "7");
        self.openUrlDiv.setAttribute("nodePath", "/settings/openUrl");
        self.openUrlDiv.innerHTML = "<span>" + moduleObj.getText("Links") + " : </span>";

        self.selectOpenUrl = document.createElement("select");
        self.selectOpenUrl.className = "rssreaderSettingsSelectOpenUrl";
        self.selectOpenUrl.id = self.selectOpenUrl.className + "_" + moduleObj.getModuleId();

        var tab_values;
        if ( moduleObj.isWindowsSticker ) {
            tab_values = [moduleObj.getText("Open in web site")];
        } else {
            tab_values = [moduleObj.getText("Open in web site"), moduleObj.getText("Open in rssreader interface")];
        }
        var nb = tab_values.length;
        for (var i=0;i<nb;i++){
            var optionSelect = document.createElement("option");
            optionSelect.value = i;
            optionSelect.innerHTML = tab_values[i];
            if ( i == moduleObj.getModNodeValue("/settings/openUrl") ){ optionSelect.selected = true; }
            self.selectOpenUrl.appendChild(optionSelect);
        }
        optionSelect = null;
        tab_values = null;
        nb = null;
        self.openUrlDiv.appendChild(self.selectOpenUrl);

        self.settingsDiv.appendChild(self.bartitleDiv);
        self.settingsDiv.appendChild(self.titleDiv);
        if ( (moduleObj.getModNodeValue("/url/@visible") == null) || (moduleObj.getModNodeValue("/url/@visible") == "1") ) {
            self.settingsDiv.appendChild(self.urlDiv);
        }
        self.settingsDiv.appendChild(self.displayModeDiv);
        self.settingsDiv.appendChild(self.nbDiv);
        self.settingsDiv.appendChild(self.openUrlDiv);

        moduleObj.setBody(self.settingsDiv);
    }

    self.saveSettings = function() {
        moduleObj.setModNodeValue("/title", self.inputTitle.value);
        moduleObj.setModNodeValue("/settings/displayMode", self.selectDisplayModeItems.options[self.selectDisplayModeItems.selectedIndex].value);
        moduleObj.setModNodeValue("/settings/nbItems", self.selectNbItems.options[self.selectNbItems.selectedIndex].value);
        moduleObj.setModNodeValue("/settings/openUrl", self.selectOpenUrl.options[self.selectOpenUrl.selectedIndex].value);
        moduleObj.saveMod();
        self.reloadBody();
    }

    /*
       \brief Return the state of the sentinel
       \return 0 : inactive - 1 : active with no keyword - 2 : active with keyword
       */
    self.getSentinelState = function() {
        if (self.getSentinel() == null) {
            // error
            return 0;
        }

        if (self.getSentinel().isActive() == false) {
            return 0;
        }

        return (self.getSentinel().getKeyword().length == 0) ? 1 : 2;
    }

    self.buildSentinelsDiv = function() {
        self.sentinelsDiv = document.createElement("div");
        self.sentinelsDiv.className = "rssreaderSentinels";
        self.sentinelsDiv.id = self.sentinelsDiv.className + "_" + moduleObj.getModuleId();
        self.sentinelsDiv.style.width = default_widget_width + default_widget_border_width + 'px';
        self.sentinelsDiv.style.backgroundImage = 'url(file://'+ APP_MODULES_PATH + '/' + moduleObj.getModuleType()+'/img/settings_background.jpg)';

        var radio0 = "checked", radio1 = "", radio2 = "";

        switch (self.getSentinelState()) {
            case 1 :
                radio0 = "";
                radio1 = "checked";
                radio2 = "";
                break;
            case 2 :
                radio0 = "";
                radio1 = "";
                radio2 = "checked";
                break;
        }
        var keywords = self.getSentinel().getKeyword();

        var tabKeywords = ["","",""];

        for(var i = 0; (i < 3) && (i < keywords.length); i ++) {
            tabKeywords[i] = self.getSentinel().getKeyword()[i];
        }

        self.sentinelsDiv.innerHTML = "<div class=\"rssreaderSentinelsBarTitle\">" + moduleObj.getText("Sentinel") + " : </div>"
            + "<div class='choice'><input type=\"radio\" name=\"sentinel\" value=\"1\"" + radio1 + " id=\"_1\"><label for=\"_1\">" + moduleObj.getText("To be informed new articles") + ".</label></div>"
            + "<div class='choice'><input type=\"radio\" name=\"sentinel\" value=\"2\" " + radio2 + " id=\"_2\"><label for=\"_2\">" + moduleObj.getText("To be informed new articles containing the key word") + "</label> : "
            + "<div class='keywords'><input type=\"text\" maxlength=\"255\" name=\"keyword\" contentEditable=\"true\" value=\"" + tabKeywords[0] + "\" size=\"14\" onclick=\"this.parentNode.previousSibling.previousSibling.previousSibling.checked = true;\">"
            + " " + moduleObj.getText("and") + " <input type=\"text\" maxlength=\"255\" name=\"keyword\" contentEditable=\"true\" value=\"" + tabKeywords[1] + "\" size=\"14\" onclick=\"this.parentNode.previousSibling.previousSibling.previousSibling.checked = true;\">"
            + " " + moduleObj.getText("and") + " <input type=\"text\" maxlength=\"255\" name=\"keyword\" contentEditable=\"true\" value=\"" + tabKeywords[2] + "\" size=\"14\" onclick=\"this.parentNode.previousSibling.previousSibling.previousSibling.checked = true;\">."
            + "</div>"
            + "</div>"
            + "<div class='choice'><input type=\"radio\" name=\"sentinel\" value=\"0\" " + radio0 + " id=\"_3\"><label for=\"_3\">" + moduleObj.getText("Disable this sentinel") + ".</label></div>";
        tabKeywords = null;
        self.setBody(self.sentinelsDiv);
    }

    self.saveSentinels = function () {
        var inputs = self.sentinelsDiv.getElementsByTagName("input");

        var tab_keywords = [inputs[2].value, inputs[3].value, inputs[4].value];
        //Si dsactive selectionn
        if ( inputs[5].checked ) {
            self.getSentinel().setState( false);
        } else if (inputs[0].checked ) {
            self.getSentinel().setState( true);
            self.getSentinel().setKeyword( new Array);
        } else if (inputs[1].checked) {
            self.getSentinel().setState( true);
            self.getSentinel().setKeyword( tab_keywords);
        }

        moduleObj.saveMod();
        // c'est l'evenement "onReporterChanged" qui recharge le module : self.reloadBody();
    }

    self.loadErrorContent = function (errorMessage) {
        moduleObj.error = true;
        if ( ! moduleObj.isRegistered() ) {
            moduleObj.setHeader(_("Error"));
        } else {
            self.buildHeaderDiv();
        }

        if (errorMessage == null) {
            errorMessage = moduleObj.getText("Unable to read feed");
        }

        var body = _$("<div class='rssreaderMain' style='width:100%;height:100%; text-align:center; padding:10px; '/>");

        body.append( "<div>" + errorMessage + "</div>");

        if ((opmlUrl != null) && (opmlUrl != "")) {
            var backToWizard = _$("<div style='padding-top:10px'><a href=#>" + moduleObj.getText("back to wizard") + "</a></div>");

            _$("a",backToWizard).click(function() {
                feedUrl = null;
                moduleObj.setModNodeValue("/@temporary", "1");
                moduleObj.reloadModules();
            });

            backToWizard.appendTo( body);
        }

        self.setBody(body.get(0));
    }

	function objectToUrlQuery( object)
	{
		var sQuery = "";

		for(var name in object)
		{
			if (!object.hasOwnProperty( name))
			{
				continue;
			}

			var value = object[name];

			if (typeof( value) != "string")
			{
                continue;
			}

			if (sQuery != "")
			{
				sQuery += '&';
			}

			sQuery += name + "=" + encodeURIComponent( value);
		}

		return sQuery;
	}

	function addUrlParameter(url,object)
	{
	    if ((!url) || (typeof(url) != "string"))
	    {
	       return null;
        }

        if (url.indexOf("?") == -1)
        {
            url += "?";
        }
        else
        {
            url += "&";
        }

        return url + objectToUrlQuery( object);
	}

    var opmlSelectedNode = null;

    // validate the wizard selection and init the module
    self.validWizardSelection = function() {
        try {
            var selectType = _$("*[name='RssReaderWizardSelectType'][checked='1']", moduleObj.getDiv()).attr( "value");;

            // if the selection of the feed url is done with the opml data
            if (selectType == 'opml') {
                if (opmlSelectedNode == null) {
                    throw new Error("Unable to find a valid opml node according to the user choice.");
                }

                if (opmlSelectedNode.childNodes.length != 0) {
                    throw new Error("Unable to select a rss feed url from a none opml node leaf.(" + node.childNodes.length + ")");
                }

                var xmlUrl = opmlSelectedNode.getAttribute("xmlUrl") || opmlSelectedNode.getAttribute("url");

                if ((xmlUrl == null) || (xmlUrl == "")) {
                    throw new Error("Invalid xmlUrl value.");
                }

                if (opmlSelectedNode.getAttribute("pubUrl") != null) {

                    moduleObj.setModNodeValue("/pubUrl", opmlSelectedNode.getAttribute("pubUrl"));
                }

                feedUrl = xmlUrl;
            } else { // free selection
                feedUrl = document.getElementById('RssReaderWizardFreeSelectionInput').value;

                if ((feedUrl == null) || (feedUrl == "")) {
                    _$(".rssreadermain .errmsg", moduleObj.getDiv()).css({display:"block"}).html(moduleObj.getText("wizard url empty"));

                    return false;
                }
            }

            // save the value
            moduleObj.setModNodeValue("/url", feedUrl);

            _$("input[@name='RssReaderWizardStickerName']", moduleObj.getDiv()).each(function() {
                moduleObj.setModNodeValue("/title", this.value);
            });

            if (!self.initReader()) {
                throw new Error("Unable to initialize reader.");
            }

            var wizardSentinelCheckbox = document.getElementById('RssReaderWizardSentinel');

            if ((self.getSentinel() != null) && (wizardSentinelCheckbox != null)) {
                self.getSentinel().setState( wizardSentinelCheckbox.checked == true);
            }

            // the module has been created so we can activate close button, sentinel button
            moduleObj.getModuleNode().removeAttribute("temporary");

            // this module has been initialized so we can remove the custom view
            moduleObj.getModuleNode().removeAttribute("view")

            moduleObj.reloadHeader();

            self.loadContent();

            return true;
        } catch(err) {
            error("An error occured while validating wizard."); error(err);
            return false;
        }
    }

    // return d if v is undefined
    function defVal(v,d) {
        return v!=undefined?v:d;
    }

    self.createWizard = function(wizardContent, opmlDocument, options) {
        if (wizardContent == null) {
            wizardContent = "";

            options=options||{};
            options.cancelMethod=defVal(options.cancelMethod, REMOVE_ALL);
            var checkSentinelStr=(options.checkSentinel==undefined)?"checked":"";

            if (opmlDocument != null) {
                // wizard with opml selection
                wizardContent +=     "       <div style='padding:5px'>";
                wizardContent +=     "                  <center><span id='RssReaderWizardTitle'><b>"+moduleObj.getText("I CREATE MY WIDGET")+"</b></span></center><BR>";
                wizardContent +=     "                    <B>"+moduleObj.getText("I choose a category then the content that interests me in the selection.")+"</B><BR>";
                wizardContent +=     "                             <fieldset style='padding:2px'>";
                wizardContent +=     "                               <legend><input type='radio' name='RssReaderWizardSelectType' value='opml' checked><B> "+moduleObj.getText("Selection from the directory of widgets")+":</B></legend>";
                wizardContent +=     "                              <div style='margin:5px'><div id='RssReaderWizardOpmlSelection'></div></div>";
                wizardContent +=     "                           </fieldset>";
                wizardContent +=     "                           <BR><B>"+moduleObj.getText("Or i just write the adress of RSS feed of my choice")+" :</B>";
                wizardContent +=     "                           <fieldset id='RssReaderWizardFreeSelection' style='padding:5px'>";
                wizardContent +=     "                           <legend><input type='radio' name='RssReaderWizardSelectType' value='free'><B>"+moduleObj.getText("Adress of RSS feed")+" :</B></legend>";
                wizardContent +=     "                           <div style='padding-top:5px;'>";
                wizardContent +=     "                           <img src='http://s.livesticker.com/c/m/img/rss/default_icon.gif'><span valign='top'> "+moduleObj.getText("URL")+" : </span><input type='text' valign='top' class='RssReaderWizardInput' id='RssReaderWizardFreeSelectionInput' contentEditable='true'>";
                wizardContent +=     "                           </div>";
                wizardContent +=     "                       </fieldset>";
                wizardContent +=     "                  <BR>";
                wizardContent +=     "                  <center><B>"+moduleObj.getText("I choose a title for my widget")+" :</B>";
                wizardContent +=     "                  <div style='margin-top:5px; width:200px;'>";
                wizardContent +=     "                          <div class='RssreaderWizardFieldTitle'>"+moduleObj.getText("Title")+"</div>";
                wizardContent +=     "                          <input type='text' class='RssReaderWizardInput' name='RssReaderWizardStickerName' contentEditable='true' style='width:100%' value='My widget'>";
                wizardContent +=     "                  </center></div>";
                wizardContent +=     "                  <div style='margin-top:5px'>";
                wizardContent +=     "                          <input id='RssReaderWizardSentinel' type='checkbox' "+checkSentinelStr+">"+moduleObj.getText("I put an alert on the widget to be alerted to each new article.");
                wizardContent +=     "                  </div>";
                wizardContent +=     "              </div>";
            } else {
                // Wizard witout opml selection
                wizardContent +=     "<div>";
                wizardContent +=     "    <div style='padding:5px'>"+moduleObj.getText("To create your widget, enter the URL of the RSS feeds of your choice.")+"</div>";
                wizardContent +=     "    <img src='http://s.livesticker.com/c/m/img/rss/default_icon.gif'><span valign='top'> "+moduleObj.getText("URL")+" : </span><input type='text' valign='top' class='RssReaderWizardInput' id='RssReaderWizardFreeSelectionInput' contentEditable='true'>";
                wizardContent +=     "</div>";
                wizardContent +=     "<div style='padding-top:10px; padding-left:5px;'> "+moduleObj.getText("I choose a title for my widget")+" :";
                wizardContent +=     " <div style='width:150px; padding:5px;'>";
                wizardContent +=     "        <div class='RssreaderWizardFieldTitle'>"+moduleObj.getText("Title")+"</div>";
                wizardContent +=     "        <input style='width:100%' name='RssReaderWizardStickerName' type='text' value='" + moduleObj.getModNodeValue("/title") + "' contentEditable='true'>";
                wizardContent +=     " </div>";
                wizardContent +=     "</div>";
                wizardContent +=     "<div style='margin-top:5px'>";
                wizardContent +=     "        <input id='RssReaderWizardSentinel' type='checkbox' "+checkSentinelStr+">"+moduleObj.getText("I put an alert on the widget to be alerted to each new article.");
                wizardContent +=     "</div>";
            }
        }

        // Create the wizard content
        var wizardDiv = _$("<div/>").addClass("rssreaderMain");

        wizardContent += "<div class='errmsg' style='width:100%; display:none; text-align:center; padding:5px; color:#FF0000;'></div>";

        wizardDiv.append( wizardContent);

        var wizardTitleNode = (opmlDocument != null) ? opmlDocument.selectSingleNode("/opml/head/wizardTitle") : null;

        if (wizardTitleNode != null) {
            _$("#RssReaderWizardTitle",wizardDiv).html( wizardTitleNode.text);
        }

        // If no validation button exist, create default buttons 'ok' and 'cancel'
        if (_$("#RssreaderWizardValidationOk",wizardDiv).length == 0) {
            var buttons = "";

            // add the buttons to validate or cancel the wizard
            buttons +=     "<div class='buttons' style='width:100%; text-align:center; padding:5px;'>";
            buttons +=     "    <img alt='ok' id='RssreaderWizardValidationOk' name='ok' style='cursor:pointer'>";
            buttons +=     "    <img alt='cancel' id='RssreaderWizardValidationCancel' name='cancel' style='cursor:pointer'>";
            buttons +=     "</div>";

            wizardDiv.append( buttons);

            var imgPath = ihmPath+"img/mod/" + window.external.getAppLang();

            // define some visual effect and bind the corresponding action
            _$(".buttons img", wizardDiv).each(function() {
                this.src = imgPath + "/bt_"+this.name+"_default.gif";
            })
            .mouseover(function() {
                this.src = imgPath + "/bt_"+this.name+"_focus.gif";
            })
            .mousedown(function() {
                this.src = imgPath + "/bt_"+this.name+"_click.gif";
            })
            .mouseout(function() {
                this.src = imgPath + "/bt_"+this.name+"_default.gif";
            })
            .click(function() {
                if (this.name == "ok") {
                    self.validWizardSelection();
                } else {
                    moduleObj.close(options.cancelMethod);                      // close the module
                }
            });
        } else { // otherwise, set the corresponding action to the existing buttons
            _$("#RssreaderWizardValidationOk",wizardDiv).click( function() {
                self.validWizardSelection();
            });

            _$("#RssreaderWizardValidationCancel",wizardDiv).click( function() {
                moduleObj.close(0);                      // close the module
            });
        }

        // Wizard configuration selector
        function selectURL() {
            _$("input[@name='RssReaderWizardStickerName']",wizardDiv).attr("value",moduleObj.getModNodeValue("/title"));

            _$("input[@name='RssReaderWizardSelectType']:nth(1)",wizardDiv).attr("checked",true);
        }

        function selectOpml() {
            if (opmlSelectedNode != null) {
                _$("input[@name='RssReaderWizardStickerName']",wizardDiv).attr("value", opmlSelectedNode.getAttribute("title") || opmlSelectedNode.getAttribute("text"));

                _$("input[@name='RssReaderWizardSelectType']:nth(0)",wizardDiv).attr("checked",true);
            } else {
                selectURL();
            }
        }

        // Select the corresponding radio button when changing value for this text field
        _$("#RssReaderWizardFreeSelectionInput",wizardDiv).keyup( function() {
            if (this.value == "") {
                selectOpml();
            } else {
                selectURL();
            }
        });

        if (opmlDocument != null) {
            // update the wizard content according to the user selection
            function OpmlSelectionChange(selectedNode) {
                // change opml selected node with the selected one
                opmlSelectedNode = selectedNode;

                selectOpml();
            }

            _$("#RssReaderWizardOpmlSelection",wizardDiv).opml({document:opmlDocument,onchange:OpmlSelectionChange});

            // set the selected node as the first outline of the opml document -- default settings
            opmlSelectedNode = opmlDocument.selectSingleNode("/opml/body//*[not(*)]");

            if (!moduleObj.getModNodeValue("/url")) {
                selectOpml();
            } else {
                _$("#RssReaderWizardFreeSelectionInput",wizardDiv).attr("value",moduleObj.getModNodeValue("/url"));

                selectURL();
            }
        }

        if (wizardDiv == null) {
            return false;
        }

        self.setBody(wizardDiv.get(0));

        return true;
    }

    self.createWizardEx = function( wizardContent, opmlDocument) {
        if (wizardContent == null) {
            if (wizardUrl != null) {
                var url = (opmlDocument != null) ? (wizardUrl + "?opmlEnable=true") : (wizardUrl + "?opmlEnable=false")

                var wizardReader = window.external.getReaderEngine().getReader("id49d3044d0d564c3da01748cdc8cb6a1e", url, "network_htmlcache");

                function WizardListener() {
                    this.onSuccess = function(event) {
                        self.createWizard( event.text, opmlDocument);
                    }

                    this.onFailure = function(event) {
                        self.createWizard( null, opmlDocument);
                    }
                }

                wizardReader.engineRequest(new WizardListener());

                return true;
            } else {
                return self.createWizard( null, opmlDocument);
            }
        } else {
            return self.createWizard( wizardContent, opmlDocument);
        }

        /*if(wizardContent)
            return self.createWizard( wizardContent, opmlDocument);

        if(!wizardUrl)
            return self.createWizard( null, opmlDocument);

        function WizardListener() {
            this.onSuccess = function(event) { self.createWizard( event.text, opmlDocument); }
            this.onFailure = function(event) { self.createWizard( null, opmlDocument); }
        }
        var url = (opmlDocument != null) ? (wizardUrl + "?opmlEnable=true") : (wizardUrl + "?opmlEnable=false")
        var wizardReader = window.external.getReaderEngine().getReader("id49d3044d0d564c3da01748cdc8cb6a1e", url, "network_htmlcache");
        wizardReader.engineRequest(new WizardListener());
        return true;*/
    }

    // load the wizard content and create it
    self.loadWizard = function() {
        self.buildHeaderDiv();
        self.setBody("<span class=\"rssreaderLoading\" style=\"height:"+_$('.modBody').height()+"px;width:"+_$('.modBody').width()+"px;padding-top:"+(Math.round(_$('.modBody').height()/2)-10)+"px;\">" + moduleObj.getText("Loading") + "</span>");
        //self.setBody("<span class=\"rssreaderLoading\">" + moduleObj.getText("Loading") + "</span>");

        if (opmlUrl) { // if an opml url is defined, use it to create the selection
            var confReader = window.external.getReaderEngine().getReader("id49d3044d0d564c3da01748cdc8cb6a1e", opmlUrl, "network_xmlmem");

            function OpmlToSelectionListener() {
                this.onSuccess = function(event) {
                    var wizardNode = event.responseXML.selectSingleNode("/opml/head/wizard");

                    self.createWizardEx( (wizardNode != null) ? wizardNode.firstChild.text : null, event.responseXML);
                }

                this.onFailure = function() { // if the opml is not reachable, display only the free selection
                    self.createWizardEx( null, null);
                }
            }

            confReader.engineRequest( new OpmlToSelectionListener(), {force:true});
        } else { // otherwise, free url selection only
            self.createWizardEx( null, null);
        }
    }

    self.loadContent = function() {


        mediaMode = false;
        ////Trace_Debug("> Begin : ",self.nameInfo,"function loadContent()");
        //Si on a deja le titre des prefs
        if ( window.external.getAppSentinel()==="1" && moduleObj.isRegistered() ) {
            //Renseigne le module sur l'tat de la sentinelle
            var msg = "";
            var sentinelActiveState = self.getSentinelState();
            if (sentinelActiveState != 0) {
                msg = moduleObj.getText("Sentinel actived") + "\n" + moduleObj.getText("Name") + " : " + moduleObj.getModNodeValue("/title") + "\n";
                if (sentinelActiveState == 2) {
                    var tabKeywords = self.getSentinel().getKeyword();

                    msg += moduleObj.getText("You will be notified for all new article containing words") + " : "
                    var tmp = "";
                    var separateur = " " + moduleObj.getText("and") + " "
                    if ( tabKeywords[0] != "" ) {
                        tmp += tabKeywords[0] + separateur;
                    }
                    if ( tabKeywords[1] != "" ) {
                        tmp += tabKeywords[1] + separateur;
                    }
                    if ( tabKeywords[2] != "" ) {
                        tmp += tabKeywords[2] + separateur;
                    }
                    if ( tmp != "" ) {
                        tmp = tmp.substring(0, tmp.length-(separateur.length) );
                    }
                    msg += tmp;
                    tabKeywords = null;
                } else {
                    msg += moduleObj.getText("You will be notified by a desktop alert for all new article");
                }
            } else {
                msg += moduleObj.getText("Sentinel disactived") + "\n" + moduleObj.getText("Click here to set a sentinel");
            }
            moduleObj.setSentinelsInfos( msg );

            if (self.alertCheckAction == true) {
                self.alertCheckAction = false;
                return;
            }
        }

        if(feedUrl) {
            self.buildHeaderDiv();

            if (reloadProcess) {
                reloadProcess = false;
                self.setBody("<span class=\"rssreaderLoading\" style=\"height:"+_$('.modBody').height()+"px;width:"+_$('.modBody').width()+"px;padding-top:"+(Math.round(_$('.modBody').height()/2)-10)+"px;\">" + moduleObj.getText("Loading") + "</span>");
                //self.setBody("<center><span class=\"rssreaderMain\">" + moduleObj.getText("Loading") + "</span></center><br>&nbsp;");
            } else {

                //_$('#loadingMsg').attr('style','').css({height:_$('body').height(), width:default_widget_width});
                _$('#loadingMsg').hide();
                var h = _$('.modBody').height();
                var p = (Math.round(+h/2)+42);
                self.setBody("<span class=\"rssreaderLoading\" style=\"height:"+_$('body').height()+"px;width:"+default_widget_width+"px;padding-top:"+p+"px;\">" + moduleObj.getText("Loading") + "</span>");
            }

            requestPending = true;

            if (!self.getReader())
            {
				return;
            }

            self.getReader().engineRequest( {onSuccess:disableRequestPending(self.loadRssFeeds), onFailure:disableRequestPending(errorloadRssFeeds), onException:disableRequestPending(exceptionLoadRssFeeds), onSimilar:disableRequestPending(self.loadRssFeeds)}, moduleObj.forceReload ? {force:true, "cache-control":"no-cache"} : {force:false});

            function errorloadRssFeeds( err ) {
                if ( err ) { //Trace_Debug("> Error" + err.status + " -- " + err.statusText,self.nameInfo,"function errorloadRssFeeds( err )");
                }
                self.loadErrorContent();
            }

            function exceptionLoadRssFeeds( err ){
                if ( err ) { //Trace_Debug("> Error" + err.status + " -- " + err.statusText,self.nameInfo,"function errorloadRssFeeds( err )");
                }
                self.loadErrorContent(moduleObj.getText("Unable to read this RSS feed.<br>The url is incorrect or the feed is not valid ..."));
            }
        } else {
            self.loadWizard();
        }
    }

    self.loadRssFeeds = function (response) {
        //Trace_Debug("> Begin : ",self.nameInfo,"function loadRssFeeds(response, xhr, xjson)");

        if ((moduleObj.sentinelsEdit == true) || (moduleObj.settingsEdit == true) || (mediaMode == true)) {
            return;
        }

        if ((response == null) || (response.responseXml == null)) {
            self.loadErrorContent(); return;
        }

        if (response.responseXml.parseError != 0) {
            self.loadErrorContent(moduleObj.getText("Unable to read this RSS feed.<br>The url is incorrect or the feed is not valid ...")); return;
        }

        //Parse le document
        var xmlDoc = response.responseXml;

        var bConfModified = false;

        //Rcupre les infos ncessaires du flux
        if ( moduleObj.getModNodeValue("/title") == "" && moduleObj.getModNodeValue("/settings/getTitle") == "1") {
            var node = xmlDoc.selectSingleNode("/rss/channel/title");
            if ( node ){
                moduleObj.setModNodeValue("/title", node.text);
                self.buildHeaderDiv();
                if ( self.titleInterface ) self.titleInterface.innerHTML = node.text;

                bConfModified = true;
            }
        }

        var node = xmlDoc.selectSingleNode("/rss/channel/link[. != '"+ moduleObj.getModNodeValue("/link") +"']");

        if (node != null) {
            moduleObj.setModNodeValue("/link", node.text);
            moduleObj.setCarrouselImage( node.text);

            bConfModified = true;
        }

        // dfini le titre de la sentinelle
        if ( self.getSentinel() ) {
            if ( self.getSentinel().getUserParam("mod_title") != moduleObj.getModNodeValue("/title") ) {
                self.getSentinel().addUserParam("mod_title", moduleObj.getModNodeValue("/title"));
            }
            if ( self.getSentinel().getUserParam("name") != moduleObj.getModNodeValue("/title") ) {
                self.getSentinel().addUserParam("name", moduleObj.getModNodeValue("/title"));
            }
        }

        if (bConfModified == true) {
            moduleObj.reloadHeader();
            moduleObj.saveMod();
        }

        self.buildMainDiv(xmlDoc);
        //Trace_Debug("> End : ",self.nameInfo,"function loadRssFeeds(response, xhr, xjson)");
    }

    self.setBody=function(msg) {

        _$(this.modBodyDiv);

        moduleObj.setBody(msg);
    }

    self.track = function (o){
        o.mid = moduleObj.getModuleId();
        //var str='';for (a in o) {str += a + ' : ' + o[a] + ' , ';}alert(str);
        window.external.track(o);
    }

    function onReaderDataReadSuccess (response) {
        if (self.noReload) {
            return;
        }
        if (self.getReader() && !requestPending) {
            self.loadRssFeeds(response)
        }
    }
    function onReaderDataReadSimilar (response) {
        //Rien
    }
    function onReaderDataException() {
        //alert('onReaderDataException');
    }

    function onReaderError() {
        //alert('onReaderError');
    }

    function onReporterChanged (event) {
        self.reloadBody();
    }

    //********************************************************************************************
    //--- INIT
    //********************************************************************************************
    //test init - Trace_Debug("> Begin : ",self.nameInfo,"INIT");

    //Chargement des valeurs du module
    // si les noeuds n'existent pas on les cre
    var tab_modNodes = ["title"
        , "url"
        , "link"
        , "icon"
        //, "ttl"
        , "settings"];
    moduleObj.setModNodes("", tab_modNodes, null);

    var tab_modNodes = ["backgroundColor"
        , "nbItems"
        , "openUrl"
        , "getFavIcon"
        , "getTitle"
        , "interface"
        , "displayMode"
        , "sentinel"];
    var tab_modNodes_defaultValues = [default_backgroundColor
        , default_nbItems
        , default_openUrl
        , default_getFavIcon
        , default_getTitle
        , default_interface
        , default_displayMode
        , ""];
    moduleObj.setModNodes("/settings", tab_modNodes, tab_modNodes_defaultValues);

    var tab_modNodes = ["keyword#3"
        ,"active"
        ,"name"];
    var tab_modNodes_defaultValues = [default_sentinel_keyword
        , default_sentinel_active
        , "" ];
    moduleObj.setModNodes("/settings/sentinel", tab_modNodes, tab_modNodes_defaultValues);

    moduleObj.setModNodes("/title", ["@option"], ["1"]);
    moduleObj.setModNodes("/url", ["@option"], ["2"]);
    moduleObj.setModNodes("/settings", ["@option"], ["1"]);
    moduleObj.setModNodes("/settings/displayMode", ["@option"], ["1"]);
    moduleObj.setModNodes("/settings/nbItems", ["@option"], ["1"]);
    moduleObj.setModNodes("/settings/openUrl", ["@option"], ["1"]);
    moduleObj.setModNodes("/settings/sentinel", ["@option"], ["1"]);

    self.initReader();
    //test init - Trace_Debug("> End : ",self.nameInfo,"INIT nodes");
}
