<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:itunes="http://www.itunes.com/dtds/podcast-1.0.dtd" xmlns:media="http://search.yahoo.com/mrss" xmlns:dm="http://www.dailymotion.com/dmrss">
    <xsl:import href="../xsl/rss_item.xsl"/>
    <xsl:output method="html" version="1.0" encoding="UTF-8" doctype-system="http://www.w3.org/TR/html4/strict.dtd" doctype-public="-//W3C//DTD HTML 4.01//EN" />

    <xsl:param name="mod_settings_displayMode" select="titles"/>
    <xsl:param name="mod_settings_openUrl" select="0"/>
    <xsl:param name="mod_settings_startIndex" select="0"/>
    <xsl:param name="mod_settings_nbItems" select="100"/>
    <xsl:param name="mod_settings_thumbnailLink" select="0"/>
    <xsl:param name="mod_cid"/>
    <xsl:param name="mod_type"/>
    <xsl:param name="mod_revision"/>
    <xsl:param name="libdock_revision"/>
    <xsl:param name="mid_id"/>
    <xsl:param name="isWindowsSticker" select="0"/>
    <xsl:param name="max_item_news_length" select="130"/>
    <xsl:param name="max_item_news_length_first" select="250"/>
    <xsl:param name="text_fichier_joint" select="attachement"/>
    <xsl:param name="text_feed_empty" select="attachement"/>
    <xsl:param name="text_read_item"/>
    <xsl:param name="rssReaderPath"></xsl:param>
    <xsl:param name="item_class"></xsl:param>
    <xsl:param name="language" select="fr"/>
    <xsl:param name="sentinel_msg_1"/>
    <xsl:param name="sentinel_msg_2"/>

    <xsl:param name="bar_title" select="'Sentinel'" />
    <xsl:param name="mod_title" select="'...'" />
    <xsl:param name="app_path" select="'0'" />

    <xsl:variable name='imgPath'>
        <xsl:value-of select='$app_path'/><xsl:text>modules/stickers/id49d3044d0d564c3da01748cdc8cb6a1e/img</xsl:text>
    </xsl:variable>
    <xsl:variable name='appUrl'>
        <xsl:text>file:///</xsl:text><xsl:value-of select="translate($app_path,'\\','/')"/>
    </xsl:variable>
    <xsl:variable name='mod_id'></xsl:variable>
    <xsl:variable name='cssRss'>
        <xsl:choose>
            <xsl:when test="language='fr'">
                <xsl:text>sentinelRssview</xsl:text>
            </xsl:when>
            <xsl:otherwise>
                <xsl:text>sentinelRssview_nopub</xsl:text>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:variable>
    
    <xsl:template match="/rss">
        <html xmlns="http://www.w3.org/1999/xhtml">
            <head>
                <script type='text/javascript' src='{$appUrl}modules/nosibox/lib/jQuery/jquery.js'></script>
                <script type='text/javascript' src='{$appUrl}modules/stickers/id49d3044d0d564c3da01748cdc8cb6a1e/sentinel/script.js'></script>
                <link type="text/css" rel='stylesheet' href="{$appUrl}modules/stickers/id49d3044d0d564c3da01748cdc8cb6a1e/css/rssItem.css" />
                <link type="text/css" rel='stylesheet' href="{$appUrl}modules/stickers/id49d3044d0d564c3da01748cdc8cb6a1e/sentinel/styles.css" />
                <script type='text/javascript'>
                    <![CDATA[
                        var urlFeed = urlBase = 'file:///]]><xsl:value-of select="link"/><![CDATA[';
                        var modPath = ']]><xsl:value-of select="$appUrl"/><![CDATA[modules/stickers/id49d3044d0d564c3da01748cdc8cb6a1e';
                        var mod = "]]><xsl:value-of select="$mid_id"/><![CDATA["
                        var msg1 = "]]><xsl:value-of select="$sentinel_msg_1"/><![CDATA[";
                        var msg2 = "]]><xsl:value-of select="$sentinel_msg_2"/><![CDATA[";
                    ]]>
                </script>
            </head>
            <body scroll="no">
                <div class="sentinelItems">
                    <xsl:apply-templates select="channel"/>
                </div>
            </body>
        </html>
    </xsl:template>

    <xsl:template match="channel">
        <div class='rssview {$cssRss}'>
        <div id="alert">
            <xsl:attribute name='style'>
                background-image:url(<xsl:value-of select="translate($imgPath,'\\','/')"/>/toolbar_bk.jpg)
            </xsl:attribute>
            <input type="checkbox" id="checkboxAlert"/>
            <div class="text"></div>
        </div>
            <xsl:choose>
                <xsl:when test="not(item)">
                    <center style='padding:10px'><xsl:value-of select='$text_feed_empty'/></center>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:choose>
                        <xsl:when test="$mod_settings_displayMode = 'titles'">
                            <xsl:for-each select="item[position() &gt;= $mod_settings_startIndex and  position() &lt; ( $mod_settings_startIndex + $mod_settings_nbItems)]">
                                <xsl:choose>
                                    <xsl:when test="position()= 1">
                                        <xsl:call-template name="itemShort">
                                            <xsl:with-param name="class">first <xsl:value-of select='$item_class'/></xsl:with-param>
                                        </xsl:call-template>
                                    </xsl:when>
                                    <xsl:when test="position() mod 2 != 1">
                                        <xsl:call-template name="itemShort">
                                            <xsl:with-param name="class">light <xsl:value-of select='$item_class'/></xsl:with-param>
                                        </xsl:call-template>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:call-template name="itemShort">
                                            <xsl:with-param name="class">dark <xsl:value-of select='$item_class'/></xsl:with-param>
                                        </xsl:call-template>
                                    </xsl:otherwise>
                                </xsl:choose>
                                <div style='clear:both'></div>
                            </xsl:for-each>
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:for-each select="item[position() &gt;= $mod_settings_startIndex and  position() &lt; ( $mod_settings_startIndex + $mod_settings_nbItems)]">
                                <xsl:choose>
                                    <xsl:when test="position()= 1">
                                        <xsl:call-template name="itemDetail">
                                            <xsl:with-param name="class">first <xsl:value-of select='$item_class'/></xsl:with-param>
                                        </xsl:call-template>
                                    </xsl:when>
                                    <xsl:when test="position() mod 2 != 1">
                                        <xsl:call-template name="itemDetail">
                                            <xsl:with-param name="class">light <xsl:value-of select='$item_class'/></xsl:with-param>
                                        </xsl:call-template>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:call-template name="itemDetail">
                                            <xsl:with-param name="class">dark <xsl:value-of select='$item_class'/></xsl:with-param>
                                        </xsl:call-template>
                                    </xsl:otherwise>
                                </xsl:choose>
                                <div style='clear:both'></div>
                            </xsl:for-each>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:otherwise>
            </xsl:choose>
        </div>
        <xsl:choose>
            <xsl:when test="language='fr'">
                <div class="pub">
                    <iframe frameborder="0" scrolling="no" id="iframe_pub" noresize="noresize" marginwidth="0" marginheight="0" src="http://store.bubbledock.com/alert_footer.php?mod={$mid_id}&amp;mod_cid={$mod_cid}&amp;mod_type={$mod_type}&amp;mod_revision={$mod_revision}&amp;v={$libdock_revision}"></iframe>
                </div>
            </xsl:when>
        </xsl:choose>
    </xsl:template>

</xsl:stylesheet>
