<?xml version="1.0" encoding="iso-8859-1"?>
  <xsl:stylesheet 
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
      xmlns:rss="http://purl.org/rss/2.0/" 
      xmlns:util="urn:nsb:utils"
      version="1.0">
  <xsl:output method="html" version="1.0" 
      indent="yes" encoding="iso-8859-1"/>
	<!-- Chemin absolu repertoire de l'application -->
	<xsl:param name="root"></xsl:param> 
  
	<xsl:param name="displaymusic">true</xsl:param>
	<xsl:param name="playerswf">player.swf</xsl:param>
   <xsl:param name="playerparams">bckgndColor=0x55A900&amp;buttonColor=0xFFFFFF&amp;buttonColorFocus=0x0C99FF&amp;imageColor=0x5E7549&amp;type=mp3</xsl:param>
	<xsl:param name="nbplayermax">15</xsl:param>
	<xsl:param name="maxitem">2</xsl:param>
	<xsl:param name="numpage">1</xsl:param>
	<xsl:param name="rssreaderPath"></xsl:param>
	<xsl:param name="text1"></xsl:param>
	<xsl:param name="text2"></xsl:param>
	<xsl:param name="text3"></xsl:param>
	
	<xsl:variable name="totalitem" select="count(/rss/channel/item)" />
	
	<xsl:template match="/rss">
				<xsl:apply-templates select="channel"/>
				
				<table width="100%" border="0" cellspacing="0" cellpadding="0" id="rssReaderInterfaceItemsT1">
					<tr>
						<td width="50%" valign="top">
							<xsl:apply-templates select="(channel/item[(position() &gt; ((number($numpage)-1)*$maxitem)) and (position() &lt;= number($numpage)*$maxitem)])">
								<xsl:with-param name="model">1</xsl:with-param>
								<xsl:with-param name="mypos">left</xsl:with-param>
							</xsl:apply-templates>
						</td>
						<td width="50%" valign="top">
							<xsl:apply-templates select="(channel/item[(position() &gt; ((number($numpage)-1)*$maxitem)) and (position() &lt;= number($numpage)*$maxitem)])">
								<xsl:with-param name="model">0</xsl:with-param>
								<xsl:with-param name="mypos">right</xsl:with-param>
							</xsl:apply-templates>
						</td>
					</tr>
					<xsl:if test="$totalitem &gt; number($maxitem)">
					<tr>
						<td width="100%" valign="top" colspan="2" align="right" class="rssReaderInterfaceItemsT1_description">
							<xsl:value-of select="$text1" />&#160;<xsl:value-of select="$totalitem" />&#160;<xsl:value-of select="$text2" />&#160;-&#160;
							<label type="nsbPagination">
							<xsl:value-of select="$text3" />&#160;:&#160;
							<xsl:if test="$totalitem &gt; 1">
									<xsl:choose>
										<xsl:when test="number($numpage) = 1">
											<b style="font-size:11px">1</b> 
										</xsl:when>
										<xsl:otherwise>
											<a href="#1" numpage="1">1</a> 
										</xsl:otherwise>
									</xsl:choose>
							</xsl:if>
							<xsl:for-each select="channel/item">
								<xsl:if test="position() mod number($maxitem) = 0 and position() &lt; $totalitem">
								 - 
									<xsl:choose>
										<xsl:when test="(position() div number($maxitem)+ 1 ) = number($numpage)">
											<b style="font-size:11px"><xsl:value-of select="(position() div number($maxitem)) + 1" /></b> 
										</xsl:when>
										<xsl:otherwise>
											<a href="#top" numpage="{(position() div number($maxitem)) + 1}"><xsl:value-of select="(position() div number($maxitem)) + 1" /></a> 
										</xsl:otherwise>
									</xsl:choose>
								</xsl:if>
							</xsl:for-each>
						</label>
						&#160;&#160;&#160;
						</td>
					</tr>
					</xsl:if>
				</table>
	
	</xsl:template>

	<xsl:template match="channel">
		
	</xsl:template>

	<xsl:template match="item">
		<xsl:param name="model"/>
		<xsl:param name="mypos"/>
		<xsl:if test="position() mod 2 = $model">
			<xsl:choose>
				<xsl:when test="$mypos = 'left'">
						<TABLE class="rssReaderInterfaceItemsT1_box" cellpadding="4" cellspacing="1">
							<TR>
								<TD class="rssReaderInterfaceItemsT1_column">
									<xsl:call-template name="titlerss" /><br/>
									<HR align="left" size="1" NOSHADE="true" COLOR="#808080" />
									<TABLE>
										<TR>
											<TD>
												<xsl:choose>
													<xsl:when test="$mypos = 'left'">
														<xsl:apply-templates select="enclosure">
															<xsl:with-param name="mypos">right</xsl:with-param>
															<xsl:with-param name="data">img</xsl:with-param>
														</xsl:apply-templates>
					                </xsl:when>
													<xsl:otherwise>
								        		<xsl:apply-templates select="enclosure">
															<xsl:with-param name="mypos">left</xsl:with-param>
															<xsl:with-param name="data">img</xsl:with-param>
														</xsl:apply-templates>
								        	</xsl:otherwise>
								    		</xsl:choose>
								    	</TD>
								    	<TD>
												<span class="rssReaderInterfaceItemsT1_description">
													<xsl:value-of select="description" disable-output-escaping="yes"/>
												</span>
											</TD>
										</TR>
									</TABLE>
									<xsl:call-template name="mytest">
										<xsl:with-param name="data">audio</xsl:with-param>
										<xsl:with-param name="withswf">0</xsl:with-param>
									</xsl:call-template>
									<br/>
									<span class="rssReaderInterfaceItemsT1_description" style="float:right">
										<xsl:call-template name="catanddate" />
									</span>
								</TD>
							</TR>
						</TABLE>
				</xsl:when>
				<xsl:when test="$mypos = 'right'">
						<TABLE class="rssReaderInterfaceItemsT1_box" cellpadding="4" cellspacing="1">
							<TR>
								<TD class="rssReaderInterfaceItemsT1_column">
									<xsl:call-template name="titlerss" /><br/>
									<HR align="left" size="1" NOSHADE="true" COLOR="#808080" />
									<TABLE>
										<TR>
											<TD>
												<xsl:choose>
													<xsl:when test="$mypos = 'left'">
														<xsl:apply-templates select="enclosure">
															<xsl:with-param name="mypos">right</xsl:with-param>
															<xsl:with-param name="data">img</xsl:with-param>
														</xsl:apply-templates>
					                </xsl:when>
													<xsl:otherwise>
								        		<xsl:apply-templates select="enclosure">
															<xsl:with-param name="mypos">left</xsl:with-param>
															<xsl:with-param name="data">img</xsl:with-param>
														</xsl:apply-templates>
								        	</xsl:otherwise>
								    		</xsl:choose>
								    	</TD>
								    	<TD>
												<span class="rssReaderInterfaceItemsT1_description">
													<xsl:value-of select="description" disable-output-escaping="yes"/>
												</span>
											</TD>
										</TR>
									</TABLE>
									<xsl:call-template name="mytest">
										<xsl:with-param name="data">audio</xsl:with-param>
										<xsl:with-param name="withswf">0</xsl:with-param>
									</xsl:call-template>
									<br/>
									<span class="rssReaderInterfaceItemsT1_description" style="float:right">
										<xsl:call-template name="catanddate" />
									</span>
								</TD>
							</TR>
						</TABLE>
				</xsl:when>
    	</xsl:choose>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="titlerss">
		<xsl:choose>
			<xsl:when test="link != ''">
				<span class="rssReaderInterfaceItemsT1_title">
				<xsl:choose>
					<xsl:when test="/rss/channel/pattern/@name != ''">
						<a href="{substring-before(/rss/channel/pattern,'$')}{link}" target="_blank">
							<xsl:value-of select="title" disable-output-escaping="yes"/>
						</a>
					</xsl:when>
					<xsl:when test="contains(link, 'javascript:nsx')">
							<a onclick="window.external.nsxeval(&quot;{link}&quot;)" href="#null">
								<xsl:value-of select="title" disable-output-escaping="yes"/>
							</a>
					</xsl:when>
					<xsl:when test="contains(substring(link,1,11) ,'javascript:')">
						<a href="#" onclick="{link}" target="_blank">
							<xsl:value-of select="title" disable-output-escaping="yes"/>
						</a>
					</xsl:when>
					<xsl:otherwise>
						<a href="{link}" target="_blank">
							<xsl:value-of select="title" disable-output-escaping="yes"/>
						</a>
					</xsl:otherwise>
				</xsl:choose>
				</span>
			</xsl:when>
			<xsl:otherwise>
				<span class="rssReaderInterfaceItemsT1_title"><xsl:value-of select="title" disable-output-escaping="yes"/></span>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="enclosure">
		<xsl:param name="mypos"/>
		<xsl:param name="data"/>
		<xsl:if test="$data = 'img'">
			<xsl:if test="@url != '' and (substring(@url,string-length(@url)-3) = 'jpeg' or substring(@url,string-length(@url)-2) = 'jpg' or substring(@url,string-length(@url)-2) = 'png' or substring(@url,string-length(@url)-2) = 'gif')">
				<div align="justify"><img src="{@url}" align="{$mypos}" class="foto_{$mypos}" /></div>
			</xsl:if>
		</xsl:if>
	</xsl:template>

	<xsl:template name="mytest">
		<xsl:param name="withswf"/>
		<xsl:choose>
			<xsl:when test="enclosure/@url != '' and substring(enclosure/@type,1,5)='audio' and $displaymusic!='link' ">
						<br/>
						<div class="enclosuremusic">
							<a url="{enclosure/@url}" href="javascript:void(0)" onclick="javascript:rssreaderPlay(this)">
							<img src="{$root}/{$rssreaderPath}/img/bt_play.gif" width="33" height="30" border="0" id="Image{position()}" type="nsb" />
							</a>
						</div>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="link != ''">
						<xsl:choose>
						  	<xsl:when test="/rss/channel/pattern/@name != ''">
								<br/>
								<a href="{substring-before(/rss/channel/pattern,'$')}{link}" target="_blank">
									<img src="{$root}/{$rssreaderPath}/img/bt_read.gif" width="43" height="19" border="0" id="Image{position()}" type="nsb" />
								</a>
							</xsl:when>
							<xsl:when test="contains(link, 'javascript:nsx')">
								<a onclick="window.external.nsxeval(&quot;{link}&quot;)" href="#null">
									<img src="{$root}/{$rssreaderPath}/img/bt_read.gif" width="43" height="19" border="0" id="Image{position()}" type="nsb" />
								</a>
							</xsl:when>	
							<xsl:when test="contains(substring(link,1,11) ,'javascript:')">
								<br/>
								<a href="#" onclick="{link}" target="_blank">
									<img src="{$root}/{$rssreaderPath}/img/bt_read.gif" width="43" height="19" border="0" id="Image{position()}" type="nsb" />
								</a>
							</xsl:when>
							<xsl:otherwise>
								<br/>
								<a href="{link}" target="_blank">
									<img src="{$root}/{$rssreaderPath}/img/bt_read.gif" width="43" height="19" border="0" id="Image{position()}" type="nsb" />
								</a>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="catanddate">
		<xsl:if test="category != ''">
			<span class="titre"><xsl:value-of select="category"/></span>
			<br />
		</xsl:if>
		<span class="date"><xsl:value-of select="pubDate" disable-output-escaping="yes"/></span>
	</xsl:template>

</xsl:stylesheet>