<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:itunes="http://www.itunes.com/dtds/podcast-1.0.dtd" xmlns:media="http://search.yahoo.com/mrss" xmlns:dm="http://www.dailymotion.com/dmrss">
  <xsl:import href="rss_item.xsl"/>

  <xsl:output method="xml" version="1.0" encoding="UTF-8"/>

  <xsl:param name="mod_id" select="0"/>
  <xsl:param name="mod_settings_displayMode" select="titles"/>
  <xsl:param name="mod_settings_openUrl" select="0"/>
  <xsl:param name="mod_settings_startIndex" select="0"/>
  <xsl:param name="mod_settings_nbItems" select="0"/>
  <xsl:param name="mod_settings_thumbnailLink" select="0"/>
  <xsl:param name="isWindowsSticker" select="0"/>
  <xsl:param name="max_item_news_length" select="180"/>
  <xsl:param name="max_item_news_length_first" select="300"/>
  <xsl:param name="text_fichier_joint">Attachment</xsl:param>
  <xsl:param name="text_feed_empty">Flux vide.</xsl:param>
  <xsl:param name="text_read_item" select="180"></xsl:param>
  <xsl:param name='rssReaderPath'></xsl:param>
  <xsl:param name='item_class'></xsl:param>
  <xsl:param name="language" select="fr"/>

  <xsl:variable name='imgPath'>
  	<xsl:value-of select='$rssReaderPath'/><xsl:text>/img</xsl:text>
  </xsl:variable>

  <xsl:template match="/rss">
    <xsl:apply-templates select="channel"/>
  </xsl:template>
	
  <xsl:template match="channel">
    <div class='rssview'>
  	  <xsl:choose>
  		  <xsl:when test="not(item)">
  		    <center style='padding:10px'><xsl:value-of select='$text_feed_empty'/></center>
  		  </xsl:when>
        <xsl:otherwise>
      	  <xsl:choose>
      		  <xsl:when test="$mod_settings_displayMode = 'titles'">
      		    <xsl:for-each select="item[position() &gt;= $mod_settings_startIndex and  position() &lt; ( $mod_settings_startIndex + $mod_settings_nbItems)]">
      	          <xsl:choose>
      	            <xsl:when test="position()= 1">
      	              <xsl:call-template name="itemShort">
      	                <xsl:with-param name="class">first <xsl:value-of select='$item_class'/></xsl:with-param>
      	              </xsl:call-template>
      	            </xsl:when>
      	            <xsl:when test="position() mod 2 = 1">
      	              <xsl:call-template name="itemShort">
      	                <xsl:with-param name="class">light <xsl:value-of select='$item_class'/></xsl:with-param>
      	              </xsl:call-template>
      	            </xsl:when>
      	            <xsl:otherwise>
      	              <xsl:call-template name="itemShort">
      	                <xsl:with-param name="class">dark <xsl:value-of select='$item_class'/></xsl:with-param>
      	              </xsl:call-template>
      	            </xsl:otherwise>
      	          </xsl:choose>
                  <div style='clear:both'></div>
      		    </xsl:for-each>
      	     </xsl:when>
      	     <xsl:otherwise>
      		    <xsl:for-each select="item[position() &gt;= $mod_settings_startIndex and  position() &lt; ( $mod_settings_startIndex + $mod_settings_nbItems)]">
      		       <xsl:choose>
      		         <xsl:when test="position()= 1">
      		           <xsl:call-template name="itemDetail">
      		             <xsl:with-param name="class">first <xsl:value-of select='$item_class'/></xsl:with-param>
      		           </xsl:call-template>
      		         </xsl:when>
      		         <xsl:when test="position() mod 2 = 1">
      		           <xsl:call-template name="itemDetail">
      		             <xsl:with-param name="class">light <xsl:value-of select='$item_class'/></xsl:with-param>
      		           </xsl:call-template>
      		         </xsl:when>
      		         <xsl:otherwise>
      		           <xsl:call-template name="itemDetail">
      		             <xsl:with-param name="class">dark <xsl:value-of select='$item_class'/></xsl:with-param>
      		           </xsl:call-template>
      		         </xsl:otherwise>
      		       </xsl:choose>
                  <div style='clear:both'></div>
      			 </xsl:for-each>
      	     </xsl:otherwise>
      	  </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
  	</div>
  </xsl:template>

</xsl:stylesheet>
