include("modules/stickers/ide6abbc178e5f452f9bd1af5c4fedbfe0/FlashObject.js");

readerEngine.declareSentinelAction("ministorefnac:alert",function(def,sentinel)
{
    // delete pending alerts when the sentinel is disabled
    sentinel.addListener(new function()
    {
        this.onParamChanged = function(e)
        {
            if (e.name == "active")
            {
                if (!sentinel.enable())
                {
                    libJS.alertEngine.alert(sentinel.getId()).dispose();
                }
            }
        }
    });

    sentinel.feed().setTtl(libJS.Registry.toNum("ministorefnac/ttl",12 * 60) * 60); // refresh feed each 12 hours

    return function(document)
    {
        var sentinelDocumentPath = libJS.fso.GetAbsolutePathName("cache/ministore/" + system.getUniqueId() + ".xml"); 
        
        // create folder to store sentinel result
        libJS.fso.CreateFolder("cache/");
        libJS.fso.CreateFolder("cache/ministore/");
        
        document.save(sentinelDocumentPath);

        var moviePath = libJS.fso.GetAbsolutePathName("modules/stickers/ide6abbc178e5f452f9bd1af5c4fedbfe0/" + this.getMoviePath());

        var flashVars = new FlashVars(this.getFlashVars());
        
        flashVars.variable('skin/minimize','false');         
        flashVars.variable('site','alert');        
        flashVars.variable('sentinelResultPath',sentinelDocumentPath); 
        flashVars.variable('applicationPath',libJS.fso.GetAbsolutePathName("modules/stickers/ide6abbc178e5f452f9bd1af5c4fedbfe0")); 

        libJS.alertEngine.create({
            id:sentinel.getId(),
            skin:"modules/stickers/ide6abbc178e5f452f9bd1af5c4fedbfe0/skin.xml",
            width:this.getWidth(),
            height:this.getHeight(),
            url:"about:blank",
            title:this.getTitle(),
            category:this.getCategory(),
            parameters:{
                moviePath:moviePath,
                flashVars:flashVars.toString(),
                moduleId:this.getModuleId()
            },
            linkedFile:{file:[sentinelDocumentPath]}
        });
    }
});

/*********** purge files create by the alert of the ministore ***************/
jsScheduler.declareAction("ministore:purgecache",function()
{
    return function()
    {
        var folder = libJS.fso.GetFolder("cache/ministore");
        
        if (!folder) 
        {
            return;
        }
        
        var files = folder.files; var today = new Date;
        
        while(files.hasNext())
        {
            var file = files.next();
            
            var modifyTime = new Date(file.modifyTime * 1000);
            
            if (today - modifyTime > libJS.Registry.toNum("ministore\\cache\\maxage",60 * 60 * 24 * 3) * 1000)
            {
                logger("ministore").trace("purge : remove '" + file.path + "'");
                
                libJS.fso.removeFile(file.path);
            } 
        }
    }
});

system.addEventListener("AppStart",function()
{
    jsScheduler.schedule("interval",{value:libJS.Registry.toNum("ministore\\cache\\purgeTTL",60 * 60 * 24 * 1)},"ministore:purgecache")
    .doAction("ministore:purgecache").onCreate(function()
    {
        this.enable(true);
    })
    .endDecl();
});